Table editor

Bootstrap 5 Table editor plugin

Table Editor is a useful tool for displaying and managing data. The component works similarly to the Datatable (docs) with an additional column for action buttons.

Responsive interactive built with the latest Bootstrap 5. Creates editable tables. Delete or edit rows directly or via modal editor.

Note: Read the API tab to find all available options and advanced customization

Note: Currently, the plugin is only compatible with the basic MDB package imported in UMD format. More about import MDB formats.


Basic example

You can initialize the component on table element by adding table-editor class to its wrapper and data-mdb-table-editor-init attribute. In this version, you don't need any additional JavaScript - set all options as data-mdb-attributes (table settings - wrapper element, column settings - th element).

When edit mode is enabled, the user shouldn't be able to interact with other parts of your website, as it can lead to loss of unsaved changes. You can toggle disable state using edit.mdb.tableEditor and editorExit.mdb.tableEditor events.

Note: search field and add button are not a build-in part of Table Editor, but you can easily initialize those functionalities in the simplest form by adding data-mdb-attributes to them (data-mdb-select, data-mdb-add-entry, and data-mdb-target).

Table Editor collects information from HTML markup to create a data structure - the <table> element will be replaced in the DOM with a different node after component initializes.


Company Address Employees
Smith & Johnson Park Lane 2, London 30
P.J. Company Oak Street 7, Aberdeen 80
Food & Wine Netherhall Gardens 3, Hampstead 12
IT Service Warwick Road 14, London 17
A. Jonson Gallery Oaklands Avenue 2, London 4
F.A. Architects Frognal Way 7, Hampstead 4
        
            
          <div class="d-flex justify-content-end mb-4">
            <div data-mdb-input-init class="form-outline">
              <input
                data-mdb-search
                data-mdb-target="#table_1"
                type="text"
                id="search_table_1"
                class="form-control"
              />
              <label class="form-label" for="search_table_1">Search</label>
            </div>
            <button data-mdb-ripple-init class="btn btn-primary btn-sm ms-3" data-mdb-add-entry data-mdb-target="#table_1">
              <i class="fa fa-plus"></i>
            </button>
          </div>
          <hr />
          <div
            class="table-editor"
            id="table_1"
            data-mdb-table-editor-init
            data-mdb-entries="5"
            data-mdb-entries-options="[5, 10, 15]"
          >
            <table class="table">
              <thead>
                <tr>
                  <th class="th-sm" data-mdb-width="250">Company</th>
                  <th class="th-sm" data-mdb-width="250" data-mdb-sort="false">Address</th>
                  <th class="th-sm" data-mdb-width="250" data-mdb-sort="false">Employees</th>
                </tr>
              </thead>
              <tbody>
                <tr>
                  <td>Smith & Johnson</td>
                  <td>Park Lane 2, London</td>
                  <td>30</td>
                </tr>
                <tr>
                  <td>P.J. Company</td>
                  <td>Oak Street 7, Aberdeen</td>
                  <td>80</td>
                </tr>
                <tr>
                  <td>Food & Wine</td>
                  <td>Netherhall Gardens 3, Hampstead</td>
                  <td>12</td>
                </tr>
                <tr>
                  <td>IT Service</td>
                  <td>Warwick Road 14, London</td>
                  <td>17</td>
                </tr>
                <tr>
                  <td>A. Jonson Gallery</td>
                  <td>Oaklands Avenue 2, London</td>
                  <td>4</td>
                </tr>
                <tr>
                  <td>F.A. Architects</td>
                  <td>Frognal Way 7, Hampstead</td>
                  <td>4</td>
                </tr>
              </tbody>
            </table>
          </div>
        
        
    


Modal

To change the default editing mode (inline) to the modal version, set option mode to "modal". If you use select in your modal make sure to declare defaultValue for that column in order for it to work properly.

        
            
          <div class="d-flex justify-content-end mb-4">
            <div data-mdb-input-init class="form-outline">
              <input
                data-mdb-search
                data-mdb-target="#table_modal"
                type="text"
                id="search_modal"
                class="form-control"
              />
              <label class="form-label" for="search_modal">Search</label>
            </div>
            <button data-mdb-ripple-init class="btn btn-primary btn-sm ms-3" data-mdb-add-entry data-mdb-target="#table_modal">
              <i class="fa fa-plus"></i>
            </button>
          </div>
          <hr />
          <div id="table_modal"></div>
        
        
    
        
            
          const advancedColumns = [
            {
              width: 250,
              label: 'Company',
              field: 'company',
            },
            {
              width: 250,
              sort: false,
              defaultValue: 'Warsaw',
              options: ['London', 'Warsaw', 'New York'],
              inputType: 'select',
              label: 'Office',
              field: 'office',
            },
            {
              width: 250,
              inputType: 'number',
              defaultValue: 1,
              label: 'Employees',
              field: 'employees',
            },
            {
              width: 100,
              defaultValue: false,
              inputType: 'checkbox',
              label: 'International',
              field: 'international',
            },
          ];

          const advancedRows = [
            {
              company: 'Smith & Johnson',
              office: 'London',
              employees: 30,
              international: true,
            },
            {
              company: 'P.J. Company',
              office: 'London',
              employees: 80,
              international: false,
            },
            {
              company: 'Food & Wine',
              office: 'London',
              employees: 12,
              international: false,
            },
            {
              company: 'IT Service',
              office: 'London',
              employees: 17,
              international: false,
            },
            {
              company: 'A. Jonson Gallery',
              office: 'London',
              employees: 4,
              international: false,
            },
            {
              company: 'F.A. Architects',
              office: 'London',
              employees: 4,
              international: false,
            },
          ];

          const tableModal = new TableEditor(
            document.getElementById('table_modal'),
            { columns: advancedColumns, rows: advancedRows },
            { mode: 'modal', entries: 5, entriesOptions: [5, 10, 15] }
          );
        
        
    

Inputs example

Table Editor supports several input types - for example, if you wish to force a user to enter only Boolean values in one column, you can set its inputType to a checkbox.

Supported input types:

  • Text (default)
  • Number
  • Checkbox - displays a checkbox in edit mode and true/false value otherwise
  • Select - additionally requires an array of options
        
            
          <div class="d-flex justify-content-end mb-4">
            <div data-mdb-input-init class="form-outline">
              <input data-mdb-search data-mdb-target="#table_inputs" type="text" id="search_table_inputs" class="form-control" />
              <label class="form-label" for="search_table_inputs">Search</label>
            </div>
            <button data-mdb-ripple-init class="btn btn-primary btn-sm ms-3" data-mdb-add-entry data-mdb-target="#table_inputs">
              <i class="fa fa-plus"></i>
            </button>
          </div>
          <hr />
          <div id="table_inputs"></div>
        
        
    
        
            
          const advancedColumns = [
            {
              width: 250,
              label: 'Company',
              field: 'company',
            },
            {
              width: 250,
              sort: false,
      defaultValue: 'new_york',
      options: [
          { key: "london", value: "London" },
          { key: "warsaw", value: "Warsaw" },
          { key: "new_york", value: "New York" },
          { key: "berlin", value: "Berlin" },
        ],
              inputType: 'select',
              label: 'Office',
              field: 'office',
            },
            {
              width: 250,
              inputType: 'number',
              defaultValue: 1,
              label: 'Employees',
              field: 'employees',
            },
            {
              width: 100,
              defaultValue: false,
              inputType: 'checkbox',
              label: 'International',
              field: 'international',
            },
          ];

          const advancedRows = [
            {
              company: 'Smith & Johnson',
              office: 'London',
              employees: 30,
              international: true,
            },
            {
              company: 'P.J. Company',
              office: 'London',
              employees: 80,
              international: false,
            },
            {
              company: 'Food & Wine',
              office: 'London',
              employees: 12,
              international: false,
            },
            {
              company: 'IT Service',
              office: 'London',
              employees: 17,
              international: false,
            },
            {
              company: 'A. Jonson Gallery',
              office: 'London',
              employees: 4,
              international: false,
            },
            {
              company: 'F.A. Architects',
              office: 'London',
              employees: 4,
              international: false,
            },
          ];

          const tableDisableEdit = new TableEditor(
            document.getElementById('table_inputs'),
            { columns: advancedColumns, rows: advancedRows },
            { entries: 5, entriesOptions: [5, 10, 15] }
          );
        
        
    

Disable edit

You can disable editing for a column by setting its editable option to false. A user won't be able to change its value in the edit mode.

        
            
          <div class="d-flex justify-content-end mb-4">
            <div data-mdb-input-init class="form-outline">
              <input
                data-mdb-search
                data-mdb-target="#table_disable_edit"
                type="text"
                id="search_disable_edit"
                class="form-control"
              />
              <label class="form-label" for="search_disable_edit">Search</label>
            </div>
            <button
              data-mdb-ripple-init
              class="btn btn-primary btn-sm ms-3"
              data-mdb-add-entry
              data-mdb-target="#table_disable_edit"
            >
              <i class="fa fa-plus"></i>
            </button>
          </div>
          <hr />
          <div id="table_disable_edit"></div>
        
        
    
        
            
          const advancedColumns = [
            {
              width: 250,
              label: 'Company',
              field: 'company',
            },
            {
              width: 250,
              sort: false,
              defaultValue: 'Warsaw',
              options: ['London', 'Warsaw', 'New York'],
              inputType: 'select',
              label: 'Office',
              field: 'office',
            },
            {
              width: 250,
              inputType: 'number',
              defaultValue: 1,
              label: 'Employees',
              field: 'employees',
            },
            {
              width: 100,
              defaultValue: false,
              inputType: 'checkbox',
              label: 'International',
              field: 'international',
            },
          ];

          const advancedRows = [
            {
              company: 'Smith & Johnson',
              office: 'London',
              employees: 30,
              international: true,
            },
            {
              company: 'P.J. Company',
              office: 'London',
              employees: 80,
              international: false,
            },
            {
              company: 'Food & Wine',
              office: 'London',
              employees: 12,
              international: false,
            },
            {
              company: 'IT Service',
              office: 'London',
              employees: 17,
              international: false,
            },
            {
              company: 'A. Jonson Gallery',
              office: 'London',
              employees: 4,
              international: false,
            },
            {
              company: 'F.A. Architects',
              office: 'London',
              employees: 4,
              international: false,
            },
          ];

          const tableDisableEdit = new TableEditor(
          document.getElementById('table_disable_edit'),
            {
              columns: advancedColumns.map((column) => {
                return {
                  ...column,
                  editable: false,
                };
              }),
              rows: advancedRows,
            },
            { entries: 5, entriesOptions: [5, 10, 15] }
          );
        
        
    

Confirm delete

If you want to prevent data from being accidentally removed, you can set a confirm option to true. In this case, Table Editor will show a Popconfirm element before removing an entry.

        
            
          <div class="d-flex justify-content-end mb-4">
            <div data-mdb-input-init class="form-outline">
              <input
                data-mdb-search
                data-mdb-target="#table_confirm_delete"
                type="text"
                id="search_confirm_delete"
                class="form-control"
              />
              <label class="form-label" for="search_confirm_delete">Search</label>
            </div>
            <button
              data-mdb-ripple-init
              class="btn btn-primary btn-sm ms-3"
              data-mdb-add-entry
              data-mdb-target="#table_confirm_delete"
            >
              <i class="fa fa-plus"></i>
            </button>
          </div>
          <hr />
          <div id="table_confirm_delete"></div>
        
        
    
        
            
          const advancedColumns = [
            {
              width: 250,
              label: 'Company',
              field: 'company',
            },
            {
              width: 250,
              sort: false,
              defaultValue: 'Warsaw',
              options: ['London', 'Warsaw', 'New York'],
              inputType: 'select',
              label: 'Office',
              field: 'office',
            },
            {
              width: 250,
              inputType: 'number',
              defaultValue: 1,
              label: 'Employees',
              field: 'employees',
            },
            {
              width: 100,
              defaultValue: false,
              inputType: 'checkbox',
              label: 'International',
              field: 'international',
            },
          ];

          const advancedRows = [
            {
              company: 'Smith & Johnson',
              office: 'London',
              employees: 30,
              international: true,
            },
            {
              company: 'P.J. Company',
              office: 'London',
              employees: 80,
              international: false,
            },
            {
              company: 'Food & Wine',
              office: 'London',
              employees: 12,
              international: false,
            },
            {
              company: 'IT Service',
              office: 'London',
              employees: 17,
              international: false,
            },
            {
              company: 'A. Jonson Gallery',
              office: 'London',
              employees: 4,
              international: false,
            },
            {
              company: 'F.A. Architects',
              office: 'London',
              employees: 4,
              international: false,
            },
          ];

          const tableConfirmDelete = new TableEditor(
            document.getElementById('table_confirm_delete'),
            { columns: advancedColumns, rows: advancedRows },
            { entries: 5, entriesOptions: [5, 10, 15], confirm: true }
          );
        
        
    


Async data

While awaiting data from API, you can prevent a user from interacting with Table Editor by setting loading option to true.

        
            
          <div class="d-flex justify-content-between mb-4">
            <button data-mdb-ripple-init id="async_data_btn" class="btn btn-primary btn-sm">
              Load data
            </button>
            <div data-mdb-input-init class="d-flex">
              <div class="form-outline">
                <input
                  type="text"
                  data-mdb-search
                  data-mdb-target="#table_async_data"
                  id="search_async"
                  class="form-control"
                />
                <label class="form-label" for="search_async">Search</label>
              </div>
              <button
                data-mdb-ripple-init
                class="btn btn-primary btn-sm ms-3"
                data-mdb-add-entry
                data-mdb-target="#table_async_data"
              >
                <i class="fa fa-plus"></i>
              </button>
            </div>
          </div>
          <hr />
          <div id="table_async_data"></div>
        
        
    
        
            
          const table = document.getElementById('table_async_data');
          const loadBtn = document.getElementById('async_data_btn');

          const columns = [
            { label: 'Company', field: 'company' },
            { label: 'Email', field: 'email' },
            { label: 'Name', field: 'name' },
            { label: 'Phone', field: 'phone' },
          ];

          const asyncTable = new TableEditor(
            table,
            { columns },
            { loading: true }
          );

          const loadData = () => {
            asyncTable.update(null, { loading: true });

            fetch('https://jsonplaceholder.typicode.com/users')
              .then((response) => response.json())
              .then((data) => {
                asyncTable.update(
                  {
                    rows: data.map((user) => ({
                      ...user,
                      address: `${user.address.city}, ${user.address.street}`,
                      company: user.company.name,
                    })),
                  },
                  { loading: false }
                );
              });
          };

          loadBtn.addEventListener('click', loadData);

          table.addEventListener('update.mdb.tableEditor', (e) => {
            // here you can create a POST request to update your database
            console.log(e.columns, e.rows);
          })
        
        
    

Custom rows

The add() method takes an optional argument - a row which values will be preloaded into a new entry.

Note: for this particular use, a row has to be an object.

Note: as adding buttons are initialized manually, they won't be automatically disabled in the edit mode.

M.B.

(5 Avenue 26, New York)

Berkley & Clark

(43th Street 12, New York)

D&D Inc.

(14 Street 67, New York)

Thomas & Co.

(2 Avenue 54, New York)


        
            
          <div id="template_list" class="row">
            <div class="col-md-3 col-sm-6 p-3">
              <h4>M.B.</h4>
              <p>(5 Avenue 26, New York)</p>
              <button
                data-mdb-ripple-init
                class="btn btn-primary btn-sm add-entry-button"
                data-mdb-company="M.B."
                data-mdb-address="5 Avenue 26"
                data-mdb-city="New York"
              >
                Load into table
              </button>
            </div>
            <div class="col-md-3 col-sm-6 p-3">
              <h4>Berkley & Clark</h4>
              <p>(43th Street 12, New York)</p>
              <button
                data-mdb-ripple-init
                class="btn btn-primary btn-sm add-entry-button"
                data-mdb-company="Berkley & Clark"
                data-mdb-address="43th Street 12"
                data-mdb-city="New York"
              >
                Load into table
              </button>
            </div>
            <div class="col-md-3 col-sm-6 p-3">
              <h4>D&D Inc.</h4>
              <p>(14 Street 67, New York)</p>
              <button
                data-mdb-ripple-init
                class="btn btn-primary btn-sm add-entry-button"
                data-mdb-company="D&D Inc."
                data-mdb-address="14 Street 67"
                data-mdb-city="New York"
              >
                Load into table
              </button>
            </div>
            <div class="col-md-3 col-sm-6 p-3">
              <h4>Thomas & Co.</h4>
              <p>(2 Avenue 54, New York)</p>
              <button
                data-mdb-ripple-init
                class="btn btn-primary btn-sm add-entry-button"
                data-mdb-company="Thomas & Co."
                data-mdb-address="2 Avenue 54"
                data-mdb-city="New York"
              >
                Load into table
              </button>
            </div>
          </div>
          <hr class="mt-3" />
          <div id="table_custom_rows"></div>
        
        
    
        
            
          const columns = [
            {
              width: 250,
              label: 'Company',
              field: 'company',
            },
            {
              width: 250,
              label: 'Address',
              field: 'address',
            },
            {
              width: 250,
              label: 'City',
              field: 'city',
            },
          ];

          const rows = [
            { company: 'Smith & Johnson', address: 'Park Lane 2', city: 'London' },
            { company: 'P.J. Company', address: 'Oak Street 7', city: 'Aberdeen' },
            { company: 'Food & Wine', address: 'Netherhall Gardens 3', city: 'Hampstead' },
            { company: 'IT Service', address: 'Warwick Road 14', city: 'London' },
            { company: 'A. Jonson Gallery', address: 'Oaklands Avenue 2', city: 'London' },
            { company: 'F.A. Architects', address: 'Frognal Way 7', city: 'Hampstead' },
          ];

          const table = document.getElementById('table_custom_rows');

          const tableEditorInstance = new TableEditor(table, { rows, columns }, { pagination: false });

          const buttons = document.querySelectorAll('.add-entry-button');

          buttons.forEach((button) => {
            button.addEventListener('click', (e) => {
              const company = e.target.getAttribute('data-mdb-company');
              const address = e.target.getAttribute('data-mdb-address');
              const city = e.target.getAttribute('data-mdb-city');

              tableEditorInstance.add({ company, address, city });

              e.target.setAttribute('disabled', true);
              e.target.innerText = 'Loaded';
            });
          });

          // disable buttons in edit mode

          table.addEventListener('edit.mdb.tableEditor', () => {
            buttons.forEach((button) => {
              button.setAttribute('disabled', true);
            });
          });

          table.addEventListener('editorExit.mdb.tableEditor', () => {
            buttons.forEach((button) => {
              if (button.innerText.toLowerCase() !== 'loaded') {
                button.removeAttribute('disabled');
              }
            });
          });
        
        
    

Notifications

In this example, handlers for custom events trigger notifications after adding/deleting/updating an entry.

        
            
          <div class="d-flex justify-content-end mb-4">
            <div data-mdb-input-init class="form-outline">
              <input
                data-mdb-search
                data-mdb-target="#table_notifications"
                type="text"
                id="search_table_notifications"
                class="form-control"
              />
              <label class="form-label" for="search_table_notifications">Search</label>
            </div>
            <button
              data-mdb-ripple-init
              class="btn btn-primary btn-sm ms-3"
              data-mdb-add-entry
              data-mdb-target="#table_notifications"
            >
              <i class="fa fa-plus"></i>
            </button>
          </div>
          <hr />
          <div id="table_notifications"></div>
          <div
            data-mdb-alert-init
            class="alert fade"
            id="alert-add-entry"
            role="alert"
            data-mdb-position="top-right"
            data-mdb-autohide="true"
            data-mdb-width="360px"
            data-mdb-color="success"
            data-mdb-hidden="true"
          >
          </div>
          <div
            data-mdb-alert-init
            class="alert fade"
            id="alert-update-entry"
            role="alert"
            data-mdb-position="top-right"
            data-mdb-autohide="true"
            data-mdb-width="360px"
            data-mdb-color="primary"
            data-mdb-hidden="true"
          ></div>
          <div
            data-mdb-alert-init
            class="alert fade"
            id="alert-remove-entry"
            role="alert"
            data-mdb-position="top-right"
            data-mdb-autohide="true"
            data-mdb-width="360px"
            data-mdb-color="danger"
            data-mdb-hidden="true"
          >
          </div>
        
        
    
        
            
          const advancedColumns = [
            {
              width: 250,
              label: 'Company',
              field: 'company',
            },
            {
              width: 250,
              sort: false,
              defaultValue: 'Warsaw',
              options: ['London', 'Warsaw', 'New York'],
              inputType: 'select',
              label: 'Office',
              field: 'office',
            },
            {
              width: 250,
              inputType: 'number',
              defaultValue: 1,
              label: 'Employees',
              field: 'employees',
            },
            {
              width: 100,
              defaultValue: false,
              inputType: 'checkbox',
              label: 'International',
              field: 'international',
            },
          ];

          const advancedRows = [
            {
              company: 'Smith & Johnson',
              office: 'London',
              employees: 30,
              international: true,
            },
            {
              company: 'P.J. Company',
              office: 'London',
              employees: 80,
              international: false,
            },
            {
              company: 'Food & Wine',
              office: 'London',
              employees: 12,
              international: false,
            },
            {
              company: 'IT Service',
              office: 'London',
              employees: 17,
              international: false,
            },
            {
              company: 'A. Jonson Gallery',
              office: 'London',
              employees: 4,
              international: false,
            },
            {
              company: 'F.A. Architects',
              office: 'London',
              employees: 4,
              international: false,
            },
          ];

          const table = document.getElementById('table_notifications');

          new TableEditor(table, { rows: advancedRows, columns: advancedColumns });

          table.addEventListener('add.mdb.tableEditor', (e) => {
            const alert = document.getElementById('alert-add-entry');
            const alertInstance = mdb.Alert.getInstance(alert);

            const { company, office } = e.row;
            alert.innerHTML = `<strong>New entry:</strong> ${company} (${office})`;

            alertInstance.show();
          });

          table.addEventListener('delete.mdb.tableEditor', (e) => {
            const alert = document.getElementById('alert-remove-entry');
            const alertInstance = mdb.Alert.getInstance(alert);

            const { company, office } = e.row;
            alert.innerHTML = `<strong>Deleted entry:</strong> ${company} (${office})`;

            alertInstance.show();
          });

          table.addEventListener('update.mdb.tableEditor', (e) => {
            const alert = document.getElementById('alert-update-entry');
            const alertInstance = mdb.Alert.getInstance(alert);

            const { company, office } = e.row;
            alert.innerHTML = `<strong>Updated entry:</strong> ${company} (${office})`;

            alertInstance.show();
          });
        
        
    

TAILWIND

GIFT for 2026

Purchase anything during the New Years Sale and get a Tailwind UI kit gift!

Table editor - API


Import

        
            
          import TableEditor from 'mdb-table-editor';
        
        
    
        
            
          @import '~mdb-table-editor/css/table-editor.min.css';
        
        
    

Usage

Via data attribute

Using the Table editor plugin doesn't require any additional JavaScript code - simply add data-mdb-table-editor-init attribute to .table-editor and use other data attributes to set all options.

        
            
        <div class="d-flex justify-content-end mb-4">
          <div data-mdb-input-init class="form-outline">
            <input
              data-mdb-search
              data-mdb-target="#table_1"
              type="text"
              id="search_table_1"
              class="form-control"
            />
            <label class="form-label" for="search_table_1">Search</label>
          </div>
          <button class="btn btn-primary btn-sm ms-3" data-mdb-add-entry data-mdb-target="#table_1">
            <i class="fa fa-plus"></i>
          </button>
        </div>
        <hr />
        <div
          data-mdb-table-editor-init
          class="table-editor"
          id="table_1"
          data-mdb-mode="modal"
          data-mdb-entries="5"
          data-mdb-entries-options="[5, 10, 15]"
        >
          <table></table>
        </div>
      
        
    

Via JavaScript

        
            
        const table = document.getElementById('my-table');
        const tableEditor = new TableEditor(table, { rows: [], columns: [], {
          mode: 'modal',
          entries: 5,
          entriesOptions: [5, 10, 15]
        }})
      
        
    

Via jQuery

Note: By default, MDB does not include jQuery and you have to add it to the project on your own.

        
            
        $(document).ready(() => { 
          $('#my-tableEditor').tableEditor({
            columns: [
              { label: 'Column 1', width: 100, fixed: true, sort: false },
              { label: 'Column 2'}
            ],
            rows: [
              ['Value 1', 'Value 2']
            ]
          }, {
             bordered: true
          })
  
          // Calling .update() with the jQuery interface:
          $('#my-tableEditor').tableEditor('update', { rows: [...], columns: [...]}, { bordered: true, loading: false })
        });
      
        
    

Options

Options can be passed via data attributes or JavaScript. For data attributes, append the option name to data-mdb-, as in data-mdb-action-header="".

Name Type Default Description
actionHeader String 'Actions' Header for action buttons
actionPosition String 'end' Decides where to render an action column (start/end)
bordered Boolean false Adds borders to a datatable
borderless Boolean false Removes all borders from a datatable
borderColor String | null null Changes a border color to one of main colors
cancelText String 'Cancel' Text displayed in cancel buttons
confirm Boolean false Displays a Popconfirm element before removing an entry
confirmText String 'Delete' Text displayed in confirm buttons (Popconfirm)
confirmMessage String 'Are you sure you want to delete this entry?' Text displayed in a Popconfirm element
color String | null null Adds a color class to a datatable (f.e 'bg-dark')
defaultValue String '' This string will be used as a placeholder if a row doesn't have a defined value for a column
entries Number 10 Number of visible entries (pagination)
editItemHeader String 'Edit item' A title displayed in edit modal
entriesOptions Array [10, 25, 50, 200] Options available to choose from in a pagination select (rows per page)
fixedHeader Boolean false When it's set to true, the table's header will remain visible while scrolling
fullPagination Boolean false Displays additional buttons for the first and last pages
hover Boolean false Changes the background color of a hovered row
loading Boolean false Sets the loading mode - disables interactions and displays a loader
loaderClass String 'bg-primary' The class name for a loader (loading mode)
loadingMessage String 'Loading results...' A message displayed while loading data
maxWidth Number | String | null null Sets a maximum width of a datatable - can be either a string ('10%') or a number of pixels.
maxHeight Number | String | null null Sets a maximum height of a datatable - can be either a string ('10%') or a number of pixels.
mode String 'inline' Changes edit mode - available options: 'inline', 'modal'
newItemHeader String 'New item' A header of modal
noFoundMessage String 'No matching results found' A message displayed when a table is empty
pagination Boolean true Shows/hides the pagination panel
saveText String 'Save' Text displayed in the save button (modal)
sm Boolean false Decreases a row's paddings
striped Boolean false Slightly changes the background's color in every other row
rowsText String 'Rows per page': A text indicating a number of rows per page

Options (column)

Name Type Default Description
defaultValue String | null null Default value only for one column
editable Boolean true Enables/disabled editing fields in this column
field String '' A field's name - will be used as a key for values in rows
fixed Boolean|String false When set to true, makes a column stick on the left while scrolling. Changing its value to right will do the same on the other side. For this option to work, you need to define width as well.
inputType String 'text' Input type for a column. Available options: 'text', 'number', 'checkbox', 'select'
label String '' A displayed header of a column
options Array | null null Array of options (for column with a "select" input type)
sort Boolean true Enables/disables sorting for this column
width Number | null null A column's width in pixels

Methods

Name Description Example
add Adds a new row (default values are optional) instance.add(row: Object)
update Updates and rerenders datatable instance.update(data: Object, options: Object)
search Filters rows so there are only those containing the searched phrase instance.search(phrase: String, column: String|Array (optional))
dispose Removes the component's instance instance.dispose()
getInstance Static method which allows you to get the table editor instance associated to a DOM element. TableEditor.getInstance(tableEditorEl)
        
            
        const tableEditorInstance = TableEditor.getInstance(document.getElementById('my-tableEditor'));

        tableEditorInstance.update({ rows: [...], columns: [...]}, { bordered: true, loading: false })
      
        
    

Events

Name Description
add.mdb.tableEditor This event fires before adding a new row. Using e.preventDefault() enables adding custom validation. You can access the added data inside a listener's handler with event.row field.
delete.mdb.tableEditor This event fires before deleting a row. Event supports use of e.preventDefault(). You can access the deleted data inside a listener's handler with event.row field.
edit.mdb.tableEditor This event fires when a user exits edit mode. Using e.preventDefault() enables adding custom validation. You can access the edited data inside a listener's handler with event.row field.
editorOpen.mdb.tableEditor This event fires when a user enters edit mode.
editorExit.mdb.tableEditor This event fires when a user exits edit mode.
update.mdb.tableEditor This event fires in an editable mode after user updates values. You can access the updated data inside a listener's handler with event.rows and event.columns fields.
render.mdb.tableEditor Event emitted after the component renders/updates rows.
        
            
        const tableEditor = document.getElementById('my-tableEditor');

        new TableEditor({ rows: [], columns: []}, { selectable: true, multi: true })

        tableEditor.addEventListener('add.mdb.tableEditor', (e) => {
          console.log(e.row)
        })

Table editor

React Bootstrap 5 Table editor plugin

Table Editor is a useful tool for displaying and managing data. The component works similarly to the React Datatable (docs) with an additional column for action buttons.

Responsive interactive built with the latest Bootstrap 5. Creates editable tables. Delete or edit rows directly or via modal editor.

Note: Read the API tab to find all available options and advanced customization


Basic example

You can initialize the component with MDBTableEditor.


Company Address Employees
Smith & Johnson Park Lane 2, London 30
P.J. Company Oak Street 7, Aberdeen 80
Food & Wine Netherhall Gardens 3, Hampstead 12
IT Service Warwick Road 14, London 17
A. Jonson Gallery Oaklands Avenue 2, London 4
F.A. Architects Frognal Way 7, Hampstead 4
        
            
            import React, { useState } from 'react';
            import { MDBTableEditor } from 'mdb-react-table-editor';

            export default function App() {
              const basicColumns = [
                {
                  width: 250,
                  label: 'Company',
                  field: 'company',
                },
                {
                  width: 250,
                  label: 'Address',
                  field: 'address',
                  sort: false,
                },
                {
                  width: 250,
                  label: 'Employees',
                  field: 'employees',
                  sort: false,
                },
              ];

              const basicRows = [
                {
                  company: 'Smith & Johnson',
                  address: 'Park Lane 2, London',
                  employees: 30,
                },
                {
                  company: 'P.J. Company',
                  address: 'Oak Street 7, Aberdeen',
                  employees: 80,
                },
                {
                  company: 'Food & Wine',
                  address: 'Netherhall Gardens 3, Hampstead',
                  employees: 12,
                },
                {
                  company: 'IT Service',
                  address: 'Warwick Road 14, London',
                  employees: 17,
                },
                {
                  company: 'A. Jonson Gallery',
                  address: 'Oaklands Avenue 2, London',
                  employees: 4,
                },
                {
                  company: 'F.A. Architects',
                  address: 'Frognal Way 7, Hampstead',
                  employees: 4,
                },
              ];

              const [basicData, setBasicData] = useState({
                columns: basicColumns,
                rows: basicRows,
              });

              return (
                <MDBTableEditor
                  onAdd={(newRow) => setBasicData({ ...basicData, rows: [...basicData.rows, newRow] })}
                  onModify={(modifiedData) => setBasicData({ ...basicData, rows: modifiedData })}
                  onDelete={(id) => setBasicData({ ...basicData, rows: basicData.rows.filter((row, i) => i !== id) })}
                  entries={5}
                  data={basicData}
                  entriesOptions={[5, 10, 15]}
                />
              );
            }
          
        
    

Modal

To change the default editing mode (inline) to the modal version, set property modal to true.

        
            
            import React, { useState } from 'react';
            import { MDBTableEditor } from 'mdb-react-table-editor';

            export default function App() {
              const advancedColumns = [
                {
                  width: 250,
                  label: 'Company',
                  field: 'company',
                },
                {
                  width: 250,
                  sort: false,
                  defaultValue: 'Warsaw',
                  options: ['London', 'Warsaw', 'New York'],
                  inputType: 'select',
                  label: 'Office',
                  field: 'office',
                },
                {
                  width: 250,
                  inputType: 'number',
                  defaultValue: 1,
                  label: 'Employees',
                  field: 'employees',
                },
                {
                  width: 100,
                  defaultValue: false,
                  inputType: 'checkbox',
                  label: 'International',
                  field: 'international',
                },
              ];

              const advancedRows = [
                {
                  company: 'Smith & Johnson',
                  office: 'London',
                  employees: 30,
                  international: true,
                },
                {
                  company: 'P.J. Company',
                  office: 'London',
                  employees: 80,
                  international: false,
                },
                {
                  company: 'Food & Wine',
                  office: 'London',
                  employees: 12,
                  international: false,
                },
                {
                  company: 'IT Service',
                  office: 'London',
                  employees: 17,
                  international: false,
                },
                {
                  company: 'A. Jonson Gallery',
                  office: 'London',
                  employees: 4,
                  international: false,
                },
                {
                  company: 'F.A. Architects',
                  office: 'London',
                  employees: 4,
                  international: false,
                },
              ];

              const [modalData, setModalData] = useState({
                columns: advancedColumns,
                rows: advancedRows,
              });

              return (
                <MDBTableEditor
                  mode='modal'
                  data={modalData}
                  entriesOptions={[5, 10, 15]}
                  entries={5}
                  onAdd={(newRow) => setModalData({ ...modalData, rows: [...modalData.rows, newRow] })}
                  onModify={(modifiedData) => setModalData({ ...modalData, rows: modifiedData })}
                  onDelete={(id) => setModalData({ ...modalData, rows: modalData.rows.filter((row, i) => i !== id) })}
                />
              );
            }
          
        
    

Inputs example

Table Editor supports several input types - for example, if you wish to force a user to enter only Boolean values in one column, you can set its inputType to a checkbox.

Supported input types:

  • Text (default)
  • Number
  • Checkbox - displays a checkbox in edit mode and true/false value otherwise
  • Select - additionally requires an array of options
        
            
            import React, { useState } from 'react';
            import { MDBTableEditor } from 'mdb-react-table-editor';

            export default function App() {
              const advancedColumns = [
                {
                  width: 250,
                  label: 'Company',
                  field: 'company',
                },
                {
                  width: 250,
                  sort: false,
                  defaultValue: 'Warsaw',
                  options: ['London', 'Warsaw', 'New York'],
                  inputType: 'select',
                  label: 'Office',
                  field: 'office',
                },
                {
                  width: 250,
                  inputType: 'number',
                  defaultValue: 1,
                  label: 'Employees',
                  field: 'employees',
                },
                {
                  width: 100,
                  defaultValue: false,
                  inputType: 'checkbox',
                  label: 'International',
                  field: 'international',
                },
              ];

              const advancedRows = [
                {
                  company: 'Smith & Johnson',
                  office: 'London',
                  employees: 30,
                  international: true,
                },
                {
                  company: 'P.J. Company',
                  office: 'London',
                  employees: 80,
                  international: false,
                },
                {
                  company: 'Food & Wine',
                  office: 'London',
                  employees: 12,
                  international: false,
                },
                {
                  company: 'IT Service',
                  office: 'London',
                  employees: 17,
                  international: false,
                },
                {
                  company: 'A. Jonson Gallery',
                  office: 'London',
                  employees: 4,
                  international: false,
                },
                {
                  company: 'F.A. Architects',
                  office: 'London',
                  employees: 4,
                  international: false,
                },
              ];

              const [basicData, setBasicData] = useState({
                columns: advancedColumns,
                rows: advancedRows,
              });


              return (
                <MDBTableEditor
                  onAdd={(newRow) => setBasicData({ ...basicData, rows: [...basicData.rows, newRow] })}
                  onModify={(modifiedData) => setBasicData({ ...basicData, rows: modifiedData })}
                  onDelete={(id) => setBasicData({ ...basicData, rows: basicData.rows.filter((row, i) => i !== id) })}
                  entries={5}
                  data={basicData}
                  entriesOptions={[5, 10, 15]}
                />
              );
            }
          
        
    

Disable edit

You can disable editing for a table by setting its editable property to false. A user won't be able to change its value in the edit mode.

        
            
            import React, { useState } from 'react';
            import { MDBTableEditor } from 'mdb-react-table-editor';

            export default function App() {
              const advancedColumns = [
                {
                  width: 250,
                  label: 'Company',
                  field: 'company',
                },
                {
                  width: 250,
                  sort: false,
                  defaultValue: 'Warsaw',
                  options: ['London', 'Warsaw', 'New York'],
                  inputType: 'select',
                  label: 'Office',
                  field: 'office',
                },
                {
                  width: 250,
                  inputType: 'number',
                  defaultValue: 1,
                  label: 'Employees',
                  field: 'employees',
                },
                {
                  width: 100,
                  defaultValue: false,
                  inputType: 'checkbox',
                  label: 'International',
                  field: 'international',
                },
              ];

              const advancedRows = [
                {
                  company: 'Smith & Johnson',
                  office: 'London',
                  employees: 30,
                  international: true,
                },
                {
                  company: 'P.J. Company',
                  office: 'London',
                  employees: 80,
                  international: false,
                },
                {
                  company: 'Food & Wine',
                  office: 'London',
                  employees: 12,
                  international: false,
                },
                {
                  company: 'IT Service',
                  office: 'London',
                  employees: 17,
                  international: false,
                },
                {
                  company: 'A. Jonson Gallery',
                  office: 'London',
                  employees: 4,
                  international: false,
                },
                {
                  company: 'F.A. Architects',
                  office: 'London',
                  employees: 4,
                  international: false,
                },
              ];

              const [disableData, setDisableData] = useState({
                columns: advancedColumns,
                rows: advancedRows,
              });

              return (
                <MDBTableEditor
                  editable={false}
                  onAdd={(newRow) => setDisableData({ ...disableData, rows: [...disableData.rows, newRow] })}
                  onModify={(modifiedData) => setDisableData({ ...disableData, rows: modifiedData })}
                  onDelete={(id) => setDisableData({ ...disableData, rows: disableData.rows.filter((row, i) => i !== id) })}
                  entries={5}
                  data={disableData}
                  entriesOptions={[5, 10, 15]}
                />
              );
            }
          
        
    

Confirm delete

If you want to prevent data from being accidentally removed, you can set a confirm option to true. In this case, Table Editor will show a Popconfirm element before removing an entry.

        
            
            import React, { useState } from 'react';
            import { MDBTableEditor } from 'mdb-react-table-editor';

            export default function App() {
              const advancedColumns = [
                {
                  width: 250,
                  label: 'Company',
                  field: 'company',
                },
                {
                  width: 250,
                  sort: false,
                  defaultValue: 'Warsaw',
                  options: ['London', 'Warsaw', 'New York'],
                  inputType: 'select',
                  label: 'Office',
                  field: 'office',
                },
                {
                  width: 250,
                  inputType: 'number',
                  defaultValue: 1,
                  label: 'Employees',
                  field: 'employees',
                },
                {
                  width: 100,
                  defaultValue: false,
                  inputType: 'checkbox',
                  label: 'International',
                  field: 'international',
                },
              ];

              const advancedRows = [
                {
                  company: 'Smith & Johnson',
                  office: 'London',
                  employees: 30,
                  international: true,
                },
                {
                  company: 'P.J. Company',
                  office: 'London',
                  employees: 80,
                  international: false,
                },
                {
                  company: 'Food & Wine',
                  office: 'London',
                  employees: 12,
                  international: false,
                },
                {
                  company: 'IT Service',
                  office: 'London',
                  employees: 17,
                  international: false,
                },
                {
                  company: 'A. Jonson Gallery',
                  office: 'London',
                  employees: 4,
                  international: false,
                },
                {
                  company: 'F.A. Architects',
                  office: 'London',
                  employees: 4,
                  international: false,
                },
              ];

              const [confirmData, setConfirmData] = useState({
                columns: advancedColumns,
                rows: advancedRows,
              });

              return (
                <MDBTableEditor
                  confirmDelete
                  data={confirmData}
                  entriesOptions={[5, 10, 15]}
                  entries={5}
                  onAdd={(newRow) => setConfirmData({ ...confirmData, rows: [...confirmData.rows, newRow] })}
                  onModify={(modifiedData) => setConfirmData({ ...confirmData, rows: modifiedData })}
                  onDelete={(id) => setConfirmData({ ...confirmData, rows: confirmData.rows.filter((row, i) => i !== id) })}
                />
              );
            }
          
        
    


Async data

While awaiting data from API, you can prevent a user from interacting with Table Editor by managing loading property.


        
            
            import React, { useState, useEffect } from 'react';
            import { MDBTableEditor } from 'mdb-react-table-editor';
            import { MDBBtn, MDBIcon } from 'mdb-react-ui-kit';

            export default function App() {
              const [loading, setLoading] = useState(false);

              const [asyncData, setAsyncData] = useState({
                columns: [
                  { label: 'Company', field: 'company' },
                  { label: 'Email', field: 'email' },
                  { label: 'Name', field: 'name' },
                  { label: 'Phone', field: 'phone' },
                ],
                rows: [],
              });

              useEffect(() => {
                if (loading) {
                  fetch('https://jsonplaceholder.typicode.com/users')
                    .then((response) => response.json())
                    .then((data) =>
                      setTimeout(() => {
                        setAsyncData({
                          columns: asyncData.columns,
                          rows: data.map((user: any) => ({
                            ...user,
                            address: `${user.address.city}, ${user.address.street}`,
                            company: user.company.name,
                          })),
                        });
                      }, 3000)
                    );
                }
              }, [loading, asyncData.columns]);

              useEffect(() => {
                if (asyncData.rows.length === 0) {
                  setLoading(true);
                } else {
                  setLoading(false);
                }
              }, [asyncData.rows]);

              return (
                <>
                  <MDBBtn className='mb-4' onClick={() => setAsyncData({ ...asyncData, rows: [] })}>
                    Reload data
                    <MDBIcon icon='sync' className='ms-2' />
                  </MDBBtn>

                  <MDBTableEditor
                    isLoading={loading}
                    data={asyncData}
                    entriesOptions={[5, 10, 15]}
                    entries={5}
                    onAdd={(newRow) => setAsyncData({ ...asyncData, rows: [...asyncData.rows, newRow] })}
                    onModify={(modifiedData) => setAsyncData({ ...asyncData, rows: modifiedData })}
                    onDelete={(id) => setAsyncData({ ...asyncData, rows: asyncData.rows.filter((row, i) => i !== id) })}
                  />
                </>
              );
            }
          
        
    

Custom rows

The add() method takes an optional argument - a row which values will be preloaded into a new entry.

Note: for this particular use, a row has to be an object.

Note: as adding buttons are initialized manually, they won't be automatically disabled in the edit mode.

M.B.

(5 Avenue 26, New York)

Berkley & Clark

(43th Street 12, New York)

D&D Inc.

(14 Street 67, New York)

Thomas & Co.

(2 Avenue 54, New York)


        
            
            import React, { useState } from 'react';
            import { MDBTableEditor } from 'mdb-react-table-editor';
            import { MDBBtn, MDBRow, MDBCol } from 'mdb-react-ui-kit';

            export default function App() {
              const basicColumns: AdvancedHeader[] = [
                {
                  width: 250,
                  label: 'Company',
                  field: 'company',
                },
                {
                  width: 250,
                  label: 'Address',
                  field: 'address',
                },
                {
                  width: 250,
                  label: 'City',
                  field: 'city',
                },
              ];
            
              const basicRows: AdvancedRecord[] = [
                { company: 'Smith & Johnson', address: 'Park Lane 2', city: 'London' },
                { company: 'P.J. Company', address: 'Oak Street 7', city: 'Aberdeen' },
                { company: 'Food & Wine', address: 'Netherhall Gardens 3', city: 'Hampstead' },
                { company: 'IT Service', address: 'Warwick Road 14', city: 'London' },
                { company: 'A. Jonson Gallery', address: 'Oaklands Avenue 2', city: 'London' },
                { company: 'F.A. Architects', address: 'Frognal Way 7', city: 'Hampstead' },
              ];

              const [customRows, setCustomRows] = useState({
                columns: basicColumns,
                rows: basicRows,
              });

              const [customLoaded, setCustomLoaded] = useState({
                row1: false,
                row2: false,
                row3: false,
                row4: false,
              });

              const { row1, row2, row3, row4 } = customLoaded;

              const loadCustom = (row: AdvancedRecord, name: string) => {
                setCustomRows({ ...customRows, rows: [...customRows.rows, row] });
            
                setCustomLoaded({ ...customLoaded, [name]: true });
              };

              return (
                <>
                  <MDBRow>
                    <MDBCol md='3' sm='6' className='p-3'>
                      <h4>M.B.</h4>
                      <p>(5 Avenue 26, New York)</p>
        
                      <MDBBtn
                        onClick={() =>
                          loadCustom(
                            {
                              company: 'M.B.',
                              address: '5 Avenue 26',
                              city: 'New York',
                            },
                            'row1'
                          )
                        }
                        disabled={row1}
                        size='sm'
                        className='add-entry-button'
                      >
                        {row1 ? 'Loaded' : 'Load into table'}
                      </MDBBtn>
                    </MDBCol>
                    <MDBCol md='3' sm='6' className='p-3'>
                      <h4>Berkley &amp; Clark</h4>
                      <p>(43th Street 12, New York)</p>
        
                      <MDBBtn
                        onClick={() =>
                          loadCustom(
                            {
                              company: 'Berkley & Clark.',
                              address: '43th Street 12',
                              city: 'New York',
                            },
                            'row2'
                          )
                        }
                        disabled={row2}
                        size='sm'
                        className='add-entry-button'
                      >
                        {row2 ? 'Loaded' : 'Load into table'}
                      </MDBBtn>
                    </MDBCol>
                    <MDBCol md='3' sm='6' className='p-3'>
                      <h4>D&amp;D Inc.</h4>
                      <p>(14 Street 67, New York)</p>
        
                      <MDBBtn
                        onClick={() =>
                          loadCustom(
                            {
                              company: 'D&D Inc.',
                              address: '14 Street 67',
                              city: 'New York',
                            },
                            'row3'
                          )
                        }
                        disabled={row3}
                        size='sm'
                        className='add-entry-button'
                      >
                        {row3 ? 'Loaded' : 'Load into table'}
                      </MDBBtn>
                    </MDBCol>
                    <MDBCol md='3' sm='6' className='p-3'>
                      <h4>Thomas &amp; Co.</h4>
                      <p>(2 Avenue 54, New York)</p>
        
                      <MDBBtn
                        onClick={() =>
                          loadCustom(
                            {
                              company: 'Thomas & Co.',
                              address: '2 Avenue 54',
                              city: 'New York',
                            },
                            'row4'
                          )
                        }
                        disabled={row4}
                        size='sm'
                        className='add-entry-button'
                      >
                        {row4 ? 'Loaded' : 'Load into table'}
                      </MDBBtn>
                    </MDBCol>
                  </MDBRow>
        
                  <MDBTableEditor
                    search={false}
                    data={customRows}
                    entriesOptions={[5, 10, 15]}
                    entries={5}
                    onAdd={(newRow) => setCustomRows({ ...customRows, rows: [...customRows.rows, newRow] })}
                    onModify={(modifiedData) => setCustomRows({ ...customRows, rows: modifiedData })}
                    onDelete={(id) => setCustomRows({ ...customRows, rows: customRows.rows.filter((row, i) => i !== id) })}
                  />
                </>
              );
            }
          
        
    

Notifications

In this example, handlers for custom events trigger notifications after adding/deleting/updating an entry.

        
            
            import React, { useState } from 'react';
            import { MDBTableEditor } from 'mdb-react-table-editor';
            import { MDBAlert } from 'mdb-react-ui-kit';

            export default function App() {
              const advancedColumns: AdvancedHeader[] = [
                {
                  width: 250,
                  label: 'Company',
                  field: 'company',
                },
                {
                  width: 250,
                  sort: false,
                  defaultValue: 'Warsaw',
                  options: ['London', 'Warsaw', 'New York'],
                  inputType: 'select' as 'number' | 'select' | 'checkbox',
                  label: 'Office',
                  field: 'office',
                },
                {
                  width: 250,
                  inputType: 'number' as 'number' | 'select' | 'checkbox',
                  defaultValue: 1,
                  label: 'Employees',
                  field: 'employees',
                },
                {
                  width: 100,
                  defaultValue: false,
                  inputType: 'checkbox' as 'number' | 'select' | 'checkbox',
                  label: 'International',
                  field: 'international',
                },
              ];
          
              const advancedRows: AdvancedRecord[] = [
                {
                  company: 'Smith & Johnson',
                  office: 'London',
                  employees: 30,
                  international: true,
                },
                {
                  company: 'P.J. Company',
                  office: 'London',
                  employees: 80,
                  international: false,
                },
                {
                  company: 'Food & Wine',
                  office: 'London',
                  employees: 12,
                  international: false,
                },
                {
                  company: 'IT Service',
                  office: 'London',
                  employees: 17,
                  international: false,
                },
                {
                  company: 'A. Jonson Gallery',
                  office: 'London',
                  employees: 4,
                  international: false,
                },
                {
                  company: 'F.A. Architects',
                  office: 'London',
                  employees: 4,
                  international: false,
                },
              ];

              const [notificationData, setNotificationData] = useState({
                columns: advancedColumns,
                rows: advancedRows,
              });

              const [addAlert, setAddAlert] = useState(false);
              const [deleteAlert, setDeleteAlert] = useState(false);
              const [updateAlert, setUpdateAlert] = useState(false);

              const [alertBody, setAlertBody] = useState({ company: '', office: '' });

              return (
                <>
                  <MDBTableEditor
                    data={notificationData}
                    entriesOptions={[5, 10, 15]}
                    entries={5}
                    onAdd={(newRow) => {
                      setAlertBody({ company: newRow.company as string, office: newRow.office as string });
                      setNotificationData({ ...notificationData, rows: [...notificationData.rows, newRow] });
        
                      setAddAlert(true);
                      setTimeout(() => {
                        setAddAlert(false);
                      }, 2000);
                    }}
                    onModify={(modifiedData, id) => {
                      setAlertBody({
                        company: modifiedData[id].company as string,
                        office: modifiedData[id].office as string,
                      });
                      setNotificationData({ ...notificationData, rows: modifiedData });
        
                      setUpdateAlert(true);
                      setTimeout(() => {
                        setUpdateAlert(false);
                      }, 2000);
                    }}
                    onDelete={(id) => {
                      setAlertBody({
                        company: notificationData.rows[id].company as string,
                        office: notificationData.rows[id].office as string,
                      });
                      setNotificationData({ ...notificationData, rows: notificationData.rows.filter((row, i) => i !== id) });
        
                      setDeleteAlert(true);
                      setTimeout(() => {
                        setDeleteAlert(false);
                      }, 2000);
                    }}
                  />

                  <MDBAlert show={addAlert} color='success' autohide width={360} position='top-right' delay={2000} appendToBody>
                    <strong>New entry: </strong>
                    {alertBody.company} ({alertBody.office})
                  </MDBAlert>
                  <MDBAlert
                    show={updateAlert}
                    color='primary'
                    autohide
                    width={360}
                    position='top-right'
                    delay={2000}
                    appendToBody
                  >
                    <strong>Updated entry: </strong>
                    {alertBody.company} ({alertBody.office})
                  </MDBAlert>
                  <MDBAlert show={deleteAlert} color='danger' autohide width={360} position='top-right' delay={2000} appendToBody>
                    <strong>Deleted entry: </strong>
                    {alertBody.company} ({alertBody.office})
                  </MDBAlert>
                </>
              );
            }
          
        
    

Dark

Dark mode can be applied to both modal and inline versions - firstly, add a CSS class which changes the background color to your page. Secondly, pass the same class name to the color option of your Table Editor (f.e. 'bg-dark'). Now change the font to light by setting dark attribute to true.


Company Address Employees
Smith & Johnson Park Lane 2, London 30
P.J. Company Oak Street 7, Aberdeen 80
Food & Wine Netherhall Gardens 3, Hampstead 12
IT Service Warwick Road 14, London 17
A. Jonson Gallery Oaklands Avenue 2, London 4
F.A. Architects Frognal Way 7, Hampstead 4
        
            
            import React, { useState } from 'react';
            import { MDBTableEditor } from 'mdb-react-table-editor';

            export default function App() {
              const advancedColumns = [
                {
                  width: 250,
                  label: 'Company',
                  field: 'company',
                },
                {
                  width: 250,
                  sort: false,
                  defaultValue: 'Warsaw',
                  options: ['London', 'Warsaw', 'New York'],
                  inputType: 'select',
                  label: 'Office',
                  field: 'office',
                },
                {
                  width: 250,
                  inputType: 'number',
                  defaultValue: 1,
                  label: 'Employees',
                  field: 'employees',
                },
                {
                  width: 100,
                  defaultValue: false,
                  inputType: 'checkbox',
                  label: 'International',
                  field: 'international',
                },
              ];

              const advancedRows = [
                {
                  company: 'Smith & Johnson',
                  office: 'London',
                  employees: 30,
                  international: true,
                },
                {
                  company: 'P.J. Company',
                  office: 'London',
                  employees: 80,
                  international: false,
                },
                {
                  company: 'Food & Wine',
                  office: 'London',
                  employees: 12,
                  international: false,
                },
                {
                  company: 'IT Service',
                  office: 'London',
                  employees: 17,
                  international: false,
                },
                {
                  company: 'A. Jonson Gallery',
                  office: 'London',
                  employees: 4,
                  international: false,
                },
                {
                  company: 'F.A. Architects',
                  office: 'London',
                  employees: 4,
                  international: false,
                },
              ];

              const [darkData, setDarkData] = useState({
                columns: advancedColumns,
                rows: advancedRows,
              });

              return (
                <MDBTableEditor
                  dark
                  data={darkData}
                  entriesOptions={[5, 10, 15]}
                  setData={(e: any) => setDarkData({ ...darkData, rows: e })}
                />
              );
            }
          
        
    

Table editor - API


Import

        
            
            import { MDBTableEditor } from 'mdb-react-ui-kit';
          
        
    

Properties

MDBTableEditor

Name Type Default Description Example
actionHeader ReactNode 'Actions' Header for action buttons <MDBTableEditor actionHeader='custom header' />
actionPosition String 'start' | 'end' Decides where to render an action column (start/end) <MDBTableEditor actionPosition='end' />
advancedSearch SelectData[] - Allows searching only for values in specific column <MDBTableEditor advancedSearch={[ { text: 'All columns', value: '' }, { text: 'Company', value: 'company' }, { text: 'Office', value: 'office' }, ]} />
allText string 'All' Changes text for All in the pagination select. <MDBTableEditor allText='test' />
bordered boolean false Adds borders to a TableEditor. <MDBTableEditor bordered />
borderless boolean false Removes all borders from a TableEditor. <MDBTableEditor borderless />
borderColor string - Changes a border color to one of main colors. <MDBTableEditor borderColor='red' />
cancelText ReactNode 'Cancel' Text displayed in cancel buttons <MDBTableEditor cancelText='Cancel' />
confirmText ReactNode 'Delete' Text displayed in confirm buttons (Popconfirm) <MDBTableEditor confirmText='custom confirm text' />
confirmMessage ReactNode 'Are you sure you want to delete this entry?' Text displayed in a Popconfirm element <MDBTableEditor confirmMessage='custom confirm message' />
color string - Adds a color class to a TableEditor (f.e 'bg-dark') <MDBTableEditor color='primary' />
data DataType - Data passed to the TableEditor. <MDBTableEditor data={data} />
dark boolean false Changes a font color to white. <MDBTableEditor dark />
editable boolean true Enable the edit mode. <MDBTableEditor editable />
editItemHeader ReactNode 'Edit item' A header of modal <MDBTableEditor editItemHeader='Adding item' />
entries number 10 Number of visible entries (pagination). <MDBTableEditor entries={25} />
entriesOptions number[] [10, 25, 50, 200] Options available to choose from in a pagination select (rows per page). <MDBTableEditor entriesOptions=[10, 20, 60] />
fixedHeader boolean false When it's set to true, the table's header will remain visible while scrolling. <MDBTableEditor fixedHeader />
format (field: string | number | symbol, value: number) => CSSProperties | undefined; - Allows formatting cells <MDBTableEditor format={(field, value) => { if (field === 'age' && value > 60) { return { backgroundColor: '#999' }; } }} />
fullPagination boolean false Displays additional buttons for the first and last pages. <MDBTableEditor fullPagination />
hover boolean false Changes the background color of a hovered row. <MDBTableEditor hover />
isLoading boolean false Set the loading mode. <MDBTableEditor isLoading />
loaderClass string 'bg-primary' The class name for a loader (loading mode). <MDBTableEditor loaderClass='bg-warning' />
loadingMessage ReactNode 'Loading results...' A message displayed while loading data. <MDBTableEditor loadingMessage='Loading...' />
maxWidth string - Sets a maximum width of a TableEditor - can be either a string ('10%') or a number of pixels. <MDBTableEditor maxWidth='560px' />
maxHeight string - Sets a maximum height of a TableEditor - can be either a string ('10%') or a number of pixels. <MDBTableEditor maxHeight='560px' />
mode 'table' | 'modal' 'table' Set table editor mode. <MDBTableEditor mode='modal' />
newItemHeader ReactNode 'New item' A header of modal <MDBTableEditor newItemHeader='Adding item' />
noFoundMessage ReactNode 'No matching results found' A message displayed when a table is empty. <MDBTableEditor noFoundMessage='Not found...' />
ofText ReactNode 'of' 'of' text in the pagination <MDBTableEditor ofText='z' />
pagination boolean true Shows/hides the pagination panel. <MDBTableEditor pagination={false} />
saveText ReactNode 'Save' Text displayed in the save button (modal)
rowsText string 'Rows per page': A text indicating a number of rows per page. <MDBTableEditor rowsText='Rows:' />
search boolean false Enable search in the table. <MDBTableEditor search />
sm boolean false Decreases a row's paddings. <MDBTableEditor sm />
striped boolean false Slightly changes the background's color in every other row. <MDBTableEditor striped />
sortField string '' Allows default sorting of the table column <MDBTableEditor sortField='ColumnName' />
sortOrder string 'asc' Defines the default sorting direction <MDBTableEditor sortField='ColumnName' sortOrder='desc' />
searchInputProps Record<string, unknown> - Props for the search input <MDBTableEditor searchInputProps={{ className: 'test' }} />

Properties

DataType

        
                  
              type DataType = {
                columns: ColumnsType;
                rows: RowsType;
              };
            
        
    

ColumnsType

        
                  
              type AdvancedHeader = {
                label: string;
                field: keyof AdvancedRecord;
                sort?: boolean;
                width?: number;
                fixed?: string;
                fixedValue?: number;
                defaultValue?: unknown;
                options?: string[];
                inputType?: 'number' | 'select' | 'checkbox';
              };
              
              type ColumnsType = AdvancedHeader[]; 
            
        
    

RowsType

        
                  
              type AdvancedRecord = Record<string, unknown>;
    
              type RowsType = AdvancedRecord[];
            
        
    

Events

Name Type Description
onRowClick (row: RecordsType) => void Event emitted after clicking on a row.
onAdd (row: AdvancedRecord) => void This event fires after adding a new row.
onModify (rows: RowsType, id: number) => void This event fires when user modifies row.
onDelete (id: number) => void This event fires after deleting a row.

Angular Bootstrap table editable
Angular Table editable - Bootstrap 4 & Material Design
Angular Bootstrap Editable Tables are components with which you can add and remove rows and change text and information within cells. In-place editing on your website - based on JavaScript - is now easier and quicker.
Basic example
Live example
<!-- Editable table -->
<div class="card">
<h3 class="card-header text-center font-weight-bold text-uppercase py-4">Editable table</h3>
<div class="card-body">
<div id="table" class="table-editable">
<span class="table-add float-right mb-3 mr-2">
<a class="text-success" (click)="add()">
<mdb-icon fas icon="plus" size="2x"></mdb-icon>
</a>
</span>
<table class="table table-bordered table-responsive-md table-striped text-center">
<tr>
<th class="text-center">Person Name</th>
<th class="text-center">Age</th>
<th class="text-center">Company Name</th>
<th class="text-center">Country</th>
<th class="text-center">City</th>
<th class="text-center">Sort</th>
<th class="text-center">Remove</th>
</tr>
<tr *ngFor="let person of personList; let id = index">
<td>
<span (keyup)="changeValue(id, 'name', $event)" (blur)="updateList(id, 'name', $event)" contenteditable="true">{{person.name}}</span>
</td>
<td>
<span contenteditable="true" (keyup)="changeValue(id, 'age', $event)" (blur)="updateList(id, 'age', $event)">{{person.age}}</span>
</td>
<td>
<span contenteditable="true" (keyup)="changeValue(id, 'companyName', $event)" (blur)="updateList(id, 'companyName', $event)">{{person.companyName}}</span>
</td>
<td>
<span contenteditable="true" (keyup)="changeValue(id, 'country', $event)" (blur)="updateList(id, 'country', $event)">{{person.country}}</span>
</td>
<td>
<span contenteditable="true" (keyup)="changeValue(id, 'city', $event)" (blur)="updateList(id, 'city', $event)">{{person.city}}</span>
</td>
<td>
<span class="table-up">
<a class="indigo-text">
<mdb-icon fas icon="long-arrow-alt-up"></mdb-icon>
</a>
</span>
<span class="table-down">
<a class="indigo-text">
<mdb-icon fas icon="long-arrow-alt-down"></mdb-icon>
</a>
</span>
</td>
<td>
<span class="table-remove">
<button type="button" mdbBtn color="danger" rounded="true" size="sm" class="my-0" (click)="remove(id)">Remove</button>
</span>
</td>
</tr>
</table>
</div>
</div>
</div>
<!-- Editable table -->
import { Component } from '@angular/core';
@Component({
selector: 'table-editable',
templateUrl: './table-editable.component.html',
styleUrls: ['./table-editable.component.css']
})
export class TableEditableComponent {
editField: string;
personList: Array<any> = [
{ id: 1, name: 'Aurelia Vega', age: 30, companyName: 'Deepends', country: 'Spain', city: 'Madrid' },
{ id: 2, name: 'Guerra Cortez', age: 45, companyName: 'Insectus', country: 'USA', city: 'San Francisco' },
{ id: 3, name: 'Guadalupe House', age: 26, companyName: 'Isotronic', country: 'Germany', city: 'Frankfurt am Main' },
{ id: 4, name: 'Aurelia Vega', age: 30, companyName: 'Deepends', country: 'Spain', city: 'Madrid' },
{ id: 5, name: 'Elisa Gallagher', age: 31, companyName: 'Portica', country: 'United Kingdom', city: 'London' },
];
awaitingPersonList: Array<any> = [
{ id: 6, name: 'George Vega', age: 28, companyName: 'Classical', country: 'Russia', city: 'Moscow' },
{ id: 7, name: 'Mike Low', age: 22, companyName: 'Lou', country: 'USA', city: 'Los Angeles' },
{ id: 8, name: 'John Derp', age: 36, companyName: 'Derping', country: 'USA', city: 'Chicago' },
{ id: 9, name: 'Anastasia John', age: 21, companyName: 'Ajo', country: 'Brazil', city: 'Rio' },
{ id: 10, name: 'John Maklowicz', age: 36, companyName: 'Mako', country: 'Poland', city: 'Bialystok' },
];
updateList(id: number, property: string, event: any) {
const editField = event.target.textContent;
this.personList[id][property] = editField;
}
remove(id: any) {
this.awaitingPersonList.push(this.personList[id]);
this.personList.splice(id, 1);
}
add() {
if (this.awaitingPersonList.length > 0) {
const person = this.awaitingPersonList[0];
this.personList.push(person);
this.awaitingPersonList.splice(0, 1);
}
}
changeValue(id: number, property: string, event: any) {
this.editField = event.target.textContent;
}
}
@media all and (min-width: 768px) {
tr {
td {
vertical-align: middle !important;
}
span {
&:not([class]) {
padding: 1rem 1rem;
}
}
}
}
Advanced table options
For advanced options of the tables have a look at specific documentation pages listed below.
Datatables
MDBootstrap integration with the most popular plugin that enhances the possibilities of standard tables.
Table pagination
Pagination is a simple navigation which lets you split a huge amount of content within the tables into smaller parts.
Table search
The MDBootstrap search box enables super fast searching through all the table data.
Table sort
This functionality lets you sort the table data according to any specific columns.
Table responsive
Table editable allows you to use tables on mobile devices.
Table styles
Table styles shows you how you can style your tables.
Angular Editable Table - API
In this section you will find advanced information about the Table component. You will find out which modules are required in this component, what are the possibilities of configuring the component, and what events and methods you can use in working with it.
Modules used
In order to speed up your application, you can choose to import only the modules you actually need, instead of importing the entire MDB Angular library. Remember that importing the entire library, and immediately afterwards a specific module, is bad practice, and can cause application errors.
// MDB Angular Pro
import { WavesModule, ButtonsModule } from 'ng-uikit-pro-standard';
Methods
The table shows the available methods in component.
Name | Parameters | Description | Example |
---|---|---|---|
remove()
|
index: number | Adds a new item to the awaitingPersonList array and removes the same item from the personList array. Takes ID of an element as a argument. |
remove(1);
|
add()
|
|
Adds a new item to the personList array, and removes the same item from the awaitingPersonList array. |
add();
|
changeValue()
|
id: number, property: string, event: event | Changes the value of the currently selected item by calling the keyup event. It takes as arguments the id of the element, property, which is to be changed in the array and event. |
changeValue(1, 'name', event);
|

Table editor

Vue Bootstrap 5 Table editor plugin

Table Editor is a useful tool for displaying and managing data. The component works similarly to the Datatable (docs) with an additional column for action buttons.

Responsive interactive built with the latest Bootstrap 5 and Vue 3. Creates editable tables. Delete or edit rows directly or via modal editor.

Note: Read the API tab to find all available options and advanced customization


Basic example

You can initialize the component via MDBTableEditor.You can pass the data to the component in two ways. First is to bind the data with an array of columns and rows to the dataset property. Second way is to create a HTML markup for your table inside MDBDatatable component - you can customize your table later by adding props to the component. Some of the more advanced options for columns, can be also used by setting data-mdb-attributes directly to a th tag (f.e. <th data-mdb-sort="false">).

When edit mode is enabled, the user shouldn't be able to interact with other parts of your website, as it can lead to loss of unsaved changes. You can control disabled state with v-model:edit property binding or by listening to edit and exit events.

Note: search field and add button are not a build-in part of Table Editor.

Table Editor collects information from HTML markup to create a data structure - the <table> element will be replaced in the DOM with a different node after component initializes.


Company Address Employees
Smith & Johnson Park Lane 2, London 30
P.J. Company Oak Street 7, Aberdeen 80
Food & Wine Netherhall Gardens 3, Hampstead 12
IT Service Warwick Road 14, London 17
A. Jonson Gallery Oaklands Avenue 2, London 4
F.A. Architects Frognal Way 7, Hampstead 4
        
            
            <template>
              <div class="d-flex justify-content-end mb-4">
                <MDBInput
                  v-model="basicSearch"
                  label="Search"
                  :disabled="basicEdit"
                />
                <MDBBtn
                  color="primary"
                  size="sm"
                  class="ms-3"
                  @click="basicEditorRef?.addRow()"
                  :disabled="basicEdit"
                >
                  <MDBIcon icon="plus"/>
                </MDBBtn>
              </div>
              <hr />
              <MDBTableEditor
                :search="basicSearch"
                :entries="5"
                :entriesOptions="[5, 10, 15]"
                v-model:edit="basicEdit"
                ref="basicEditorRef"
              >
                <table class="table">
                  <thead>
                    <tr>
                      <th class="th-sm" data-mdb-width="250">Company</th>
                      <th class="th-sm" data-mdb-width="250" data-mdb-sort="false">
                        Address
                      </th>
                      <th class="th-sm" data-mdb-width="250" data-mdb-sort="false">
                        Employees
                      </th>
                    </tr>
                  </thead>
                  <tbody>
                    <tr>
                      <td>Smith & Johnson</td>
                      <td>Park Lane 2, London</td>
                      <td>30</td>
                    </tr>
                    <tr>
                      <td>P.J. Company</td>
                      <td>Oak Street 7, Aberdeen</td>
                      <td>80</td>
                    </tr>
                    <tr>
                      <td>Food & Wine</td>
                      <td>Netherhall Gardens 3, Hampstead</td>
                      <td>12</td>
                    </tr>
                    <tr>
                      <td>IT Service</td>
                      <td>Warwick Road 14, London</td>
                      <td>17</td>
                    </tr>
                    <tr>
                      <td>A. Jonson Gallery</td>
                      <td>Oaklands Avenue 2, London</td>
                      <td>4</td>
                    </tr>
                    <tr>
                      <td>F.A. Architects</td>
                      <td>Frognal Way 7, Hampstead</td>
                      <td>4</td>
                    </tr>
                  </tbody>
                </table>
              </MDBTableEditor>
            </template>
          
        
    
        
            
            <script>
              import { MDBInput, MDBBtn, MDBIcon } from "mdb-vue-ui-kit";
              import { MDBTableEditor } from "mdb-vue-table-editor";
              import { ref } from "vue";
              export default {
                components: {
                  MDBInput, MDBBtn, MDBIcon, MDBTableEditor
                },
                setup() {
                  const basicEditorRef = ref(null);
                  const basicSearch = ref("");
                  const basicEdit = ref(false);

                  return {
                    basicEditorRef,
                    basicSearch,
                    basicEdit,
                  }
                }
              };
            </script>
          
        
    
        
            
            <script setup lang="ts">
              import { MDBInput, MDBBtn, MDBIcon } from "mdb-vue-ui-kit";
              import { MDBTableEditor } from "mdb-vue-table-editor";
              import { ref } from "vue";

              const basicEditorRef = ref<InstanceType<typeof MDBTableEditor> | null>(null);
              const basicSearch = ref("");
              const basicEdit = ref(false);
            </script>
          
        
    

Modal

To change the default editing mode (inline) to the modal version, set option mode to "modal".

        
            
            <template>
              <div class="d-flex justify-content-end mb-4">
                <MDBInput v-model="modalSearch" label="Search" :disabled="modalEdit" />
                <MDBBtn 
                  color="primary" 
                  size="sm" 
                  class="ms-3" 
                  @click="modalEditorRef?.addRow()" 
                  :disabled="modalEdit"
                >
                  <MDBIcon icon="plus"/>
                </MDBBtn>
              </div>
              <hr />
              <MDBTableEditor 
                mode="modal"
                v-model:dataset="modalData" 
                :search="modalSearch" 
                :entries="5"
                :entriesOptions="[5, 10, 15]" 
                v-model:edit="modalEdit" 
                ref="modalEditorRef" 
              />
            </template>
          
        
    
        
            
            <script>
              import { MDBInput, MDBBtn, MDBIcon } from "mdb-vue-ui-kit";
              import { MDBTableEditor } from "mdb-vue-table-editor";
              import { ref } from "vue";
              export default {
                components: {
                  MDBInput, MDBBtn, MDBIcon, MDBTableEditor
                },
                setup() {
                  const modalEditorRef = ref(null);
                  const modalSearch = ref("");
                  const modalEdit = ref(false);
                  const modalData = ref({
                    columns: [
                      {
                        width: 250,
                        label: "Company",
                        field: "company",
                      },
                      {
                        width: 250,
                        sort: false,
                        defaultValue: "Warsaw",
                        options: ["London", "Warsaw", "New York"],
                        inputType: "select",
                        label: "Office",
                        field: "office",
                      },
                      {
                        width: 250,
                        inputType: "number",
                        defaultValue: 1,
                        label: "Employees",
                        field: "employees",
                      },
                      {
                        width: 100,
                        defaultValue: false,
                        inputType: "checkbox",
                        label: "International",
                        field: "international",
                      },
                    ],
                    rows: [
                      {
                        company: "Smith & Johnson",
                        office: "London",
                        employees: 30,
                        international: true,
                      },
                      {
                        company: "P.J. Company",
                        office: "London",
                        employees: 80,
                        international: false,
                      },
                      {
                        company: "Food & Wine",
                        office: "London",
                        employees: 12,
                        international: false,
                      },
                      {
                        company: "IT Service",
                        office: "London",
                        employees: 17,
                        international: false,
                      },
                      {
                        company: "A. Jonson Gallery",
                        office: "London",
                        employees: 4,
                        international: false,
                      },
                      {
                        company: "F.A. Architects",
                        office: "London",
                        employees: 4,
                        international: false,
                      }
                    ]
                  });
                  return {
                    modalEditorRef,
                    modalSearch,
                    modalEdit,
                    modalData,
                  }
                }
              };
            </script>
          
        
    
        
            
            <script setup lang="ts">
              import { MDBInput, MDBBtn, MDBIcon } from "mdb-vue-ui-kit";
              import { MDBTableEditor } from "mdb-vue-table-editor";
              import { ref } from "vue";

              const modalEditorRef = ref<InstanceType<typeof MDBTableEditor> | null>(null);
              const modalSearch = ref("");
              const modalEdit = ref(false);
              const modalData = ref({
                columns: [
                  {
                    width: 250,
                    label: "Company",
                    field: "company",
                  },
                  {
                    width: 250,
                    sort: false,
                    defaultValue: "Warsaw",
                    options: ["London", "Warsaw", "New York"],
                    inputType: "select",
                    label: "Office",
                    field: "office",
                  },
                  {
                    width: 250,
                    inputType: "number",
                    defaultValue: 1,
                    label: "Employees",
                    field: "employees",
                  },
                  {
                    width: 100,
                    defaultValue: false,
                    inputType: "checkbox",
                    label: "International",
                    field: "international",
                  },
                ],
                rows: [
                  {
                    company: "Smith & Johnson",
                    office: "London",
                    employees: 30,
                    international: true,
                  },
                  {
                    company: "P.J. Company",
                    office: "London",
                    employees: 80,
                    international: false,
                  },
                  {
                    company: "Food & Wine",
                    office: "London",
                    employees: 12,
                    international: false,
                  },
                  {
                    company: "IT Service",
                    office: "London",
                    employees: 17,
                    international: false,
                  },
                  {
                    company: "A. Jonson Gallery",
                    office: "London",
                    employees: 4,
                    international: false,
                  },
                  {
                    company: "F.A. Architects",
                    office: "London",
                    employees: 4,
                    international: false,
                  }
                ]
              });
            </script>
          
        
    

Inputs example

Table Editor supports several input types - for example, if you wish to force a user to enter only Boolean values in one column, you can set its inputType to a checkbox.

Supported input types:

  • Text (default)
  • Number
  • Checkbox - displays a checkbox in edit mode and true/false value otherwise
  • Select - additionally requires an array of options
  • Autocomplete - additionally requires a filter method inside the filter property. Check the autocomplete page to see how it should look like
  • Datepicker - add props property to provide additional options to the datepicker
  • Timepicker - add props property to provide additional options to the datepicker
        
            
            <template>
              <div class="d-flex justify-content-end mb-4">
                <MDBInput v-model="inputsSearch" label="Search" :disabled="inputsEdit" />
                <MDBBtn 
                  color="primary" 
                  size="sm" 
                  class="ms-3" 
                  @click="inputsEditorRef?.addRow()" 
                  :disabled="inputsEdit"
                >
                  <MDBIcon icon="plus"/>
                </MDBBtn>
              </div>
              <hr />
              <MDBTableEditor 
                v-model:dataset="inputsData" 
                :search="inputsSearch" 
                :entries="5" 
                :entriesOptions="[5, 10, 15]"
                v-model:edit="inputsEdit" 
                ref="inputsEditorRef" 
              />
            </template>
          
        
    
        
            
            <script>
              import { MDBInput, MDBBtn, MDBIcon } from "mdb-vue-ui-kit";
              import { MDBTableEditor } from "mdb-vue-table-editor";
              import { ref } from "vue";

              export default {
                components: {
                  MDBInput, MDBBtn, MDBIcon, MDBTableEditor
                },
                setup() {
                  const inputsEditorRef = ref(null);
                  const inputsSearch = ref("");
                  const inputsEdit = ref(false);
                  const inputsData = ref({
                    columns: [
                      {
                        width: 250,
                        label: "Company",
                        field: "company",
                      },
                      {
                        width: 250,
                        sort: false,
                        defaultValue: "Warsaw",
                        options: ["London", "Warsaw", "New York"],
                        inputType: "select",
                        label: "Office",
                        field: "office",
                      },
                      {
                        width: 250,
                        inputType: "number",
                        defaultValue: 1,
                        label: "Employees",
                        field: "employees",
                      },
                      {
                        width: 100,
                        defaultValue: false,
                        inputType: "checkbox",
                        label: "International",
                        field: "international",
                      },
                    ],
                    rows: [
                      {
                        company: "Smith & Johnson",
                        office: "London",
                        employees: 30,
                        international: true,
                      },
                      {
                        company: "P.J. Company",
                        office: "London",
                        employees: 80,
                        international: false,
                      },
                      {
                        company: "Food & Wine",
                        office: "London",
                        employees: 12,
                        international: false,
                      },
                      {
                        company: "IT Service",
                        office: "London",
                        employees: 17,
                        international: false,
                      },
                      {
                        company: "A. Jonson Gallery",
                        office: "London",
                        employees: 4,
                        international: false,
                      },
                      {
                        company: "F.A. Architects",
                        office: "London",
                        employees: 4,
                        international: false,
                      }
                    ]
                  });

                  return {
                    inputsEdit,
                    inputsEditorRef,
                    inputsSearch,
                    inputsData,
                  }
                }
              }
            </script>
          
        
    
        
            
            <script setup lang="ts">
              import { MDBInput, MDBBtn, MDBIcon } from "mdb-vue-ui-kit";
              import { MDBTableEditor } from "mdb-vue-table-editor";
              import { ref } from "vue";

              const inputsEditorRef = ref<InstanceType<typeof MDBTableEditor> | null>(null);
              const inputsSearch = ref("");
              const inputsEdit = ref(false);
              const inputsData = ref({
                columns: [
                  {
                    width: 250,
                    label: "Company",
                    field: "company",
                  },
                  {
                    width: 250,
                    sort: false,
                    defaultValue: "Warsaw",
                    options: ["London", "Warsaw", "New York"],
                    inputType: "select",
                    label: "Office",
                    field: "office",
                  },
                  {
                    width: 250,
                    inputType: "number",
                    defaultValue: 1,
                    label: "Employees",
                    field: "employees",
                  },
                  {
                    width: 100,
                    defaultValue: false,
                    inputType: "checkbox",
                    label: "International",
                    field: "international",
                  },
                ],
                rows: [
                  {
                    company: "Smith & Johnson",
                    office: "London",
                    employees: 30,
                    international: true,
                  },
                  {
                    company: "P.J. Company",
                    office: "London",
                    employees: 80,
                    international: false,
                  },
                  {
                    company: "Food & Wine",
                    office: "London",
                    employees: 12,
                    international: false,
                  },
                  {
                    company: "IT Service",
                    office: "London",
                    employees: 17,
                    international: false,
                  },
                  {
                    company: "A. Jonson Gallery",
                    office: "London",
                    employees: 4,
                    international: false,
                  },
                  {
                    company: "F.A. Architects",
                    office: "London",
                    employees: 4,
                    international: false,
                  }
                ]
              });
            </script>
          
        
    

Disable edit

You can disable editing for a column by setting its editable option to false. A user won't be able to change its value in the edit mode.

        
            
            <template>
              <div class="d-flex justify-content-end mb-4">
                <MDBInput v-model="disabledSearch" label="Search" :disabled="disabledEdit" />
                <MDBBtn 
                  color="primary" 
                  size="sm" 
                  class="ms-3" 
                  @click="disabledEditorRef?.addRow()" 
                  :disabled="disabledEdit"
                >
                  <MDBIcon icon="plus"/>
                </MDBBtn>
              </div>
              <hr />
              <MDBTableEditor 
                v-model:dataset="disabledData" 
                :search="disabledSearch" 
                :entries="5" 
                :entriesOptions="[5, 10, 15]"
                v-model:edit="disabledEdit" 
                ref="disabledEditorRef" 
              />
            </template>
          
        
    
        
            
            <script>
              import { MDBInput, MDBBtn, MDBIcon } from "mdb-vue-ui-kit";
              import { MDBTableEditor } from "mdb-vue-table-editor";
              import { ref } from "vue";
              
              export default {
                components: {
                  MDBInput, MDBBtn, MDBIcon, MDBTableEditor
                },
                setup() {
                  const disabledEditorRef = ref(null);
                  const disabledSearch = ref("");
                  const disabledEdit = ref(false);
                  const disabledData = ref({
                    columns: [
                      {
                        width: 250,
                        label: "Company",
                        field: "company",
                        editable: false
                      },
                      {
                        width: 250,
                        sort: false,
                        defaultValue: "Warsaw",
                        options: ["London", "Warsaw", "New York"],
                        inputType: "select",
                        label: "Office",
                        field: "office",
                        editable: false
                      },
                      {
                        width: 250,
                        inputType: "number",
                        defaultValue: 1,
                        label: "Employees",
                        field: "employees",
                        editable: false
                      },
                      {
                        width: 100,
                        defaultValue: false,
                        inputType: "checkbox",
                        label: "International",
                        field: "international",
                        editable: false
                      },
                    ],
                    rows: [
                      {
                        company: "Smith & Johnson",
                        office: "London",
                        employees: 30,
                        international: true,
                      },
                      {
                        company: "P.J. Company",
                        office: "London",
                        employees: 80,
                        international: false,
                      },
                      {
                        company: "Food & Wine",
                        office: "London",
                        employees: 12,
                        international: false,
                      },
                      {
                        company: "IT Service",
                        office: "London",
                        employees: 17,
                        international: false,
                      },
                      {
                        company: "A. Jonson Gallery",
                        office: "London",
                        employees: 4,
                        international: false,
                      },
                      {
                        company: "F.A. Architects",
                        office: "London",
                        employees: 4,
                        international: false,
                      }
                    ]
                  });
                  
                  return {
                    disabledEditorRef,
                    disabledSearch,
                    disabledEdit,
                    disabledData,
                  }
                }
              };
            </script>
          
        
    
        
            
            <script setup lang="ts">
              import { MDBInput, MDBBtn, MDBIcon } from "mdb-vue-ui-kit";
              import { MDBTableEditor } from "mdb-vue-table-editor";
              import { ref } from "vue";

              const disabledEditorRef = ref<InstanceType<typeof MDBTableEditor> | null>(null);
              const disabledSearch = ref("");
              const disabledEdit = ref(false);
              const disabledData = ref({
                columns: [
                  {
                     width: 250,
                    label: "Company",
                    field: "company",
                    editable: false
                  },
                  {
                    width: 250,
                    sort: false,
                    defaultValue: "Warsaw",
                    options: ["London", "Warsaw", "New York"],
                    inputType: "select",
                    label: "Office",
                    field: "office",
                    editable: false
                  },
                  {
                    width: 250,
                    inputType: "number",
                    defaultValue: 1,
                    label: "Employees",
                    field: "employees",
                    editable: false
                  },
                  {
                    width: 100,
                    defaultValue: false,
                    inputType: "checkbox",
                    label: "International",
                    field: "international",
                    editable: false
                  },
                ],
                rows: [
                  {
                    company: "Smith & Johnson",
                    office: "London",
                    employees: 30,
                    international: true,
                  },
                  {
                    company: "P.J. Company",
                    office: "London",
                    employees: 80,
                    international: false,
                  },
                  {
                    company: "Food & Wine",
                    office: "London",
                    employees: 12,
                    international: false,
                  },
                  {
                    company: "IT Service",
                    office: "London",
                    employees: 17,
                    international: false,
                  },
                  {
                    company: "A. Jonson Gallery",
                    office: "London",
                    employees: 4,
                    international: false,
                  },
                  {
                    company: "F.A. Architects",
                    office: "London",
                    employees: 4,
                    international: false,
                  }
                ]
              });
            </script>
          
        
    

Confirm delete

If you want to prevent data from being accidentally removed, you can set a confirm option to true. In this case, Table Editor will show a Popconfirm element before removing an entry.

        
            
            <template>
              <div class="d-flex justify-content-end mb-4">
                <MDBInput v-model="confirmSearch" label="Search" :disabled="confirmEdit" />
                <MDBBtn 
                  color="primary" 
                  size="sm" 
                  class="ms-3" 
                  @click="confirmEditorRef?.addRow()" 
                  :disabled="confirmEdit"
                >
                  <MDBIcon icon="plus"/>
                </MDBBtn>
              </div>
              <hr />
              <MDBTableEditor 
                confirm 
                v-model:dataset="confirmData" 
                :search="confirmSearch" 
                :entries="5" 
                :entriesOptions="[5, 10, 15]"
                v-model:edit="confirmEdit" 
                ref="confirmEditorRef" 
              />
            </template>
          
        
    
        
            
            <script>
              import { MDBInput, MDBBtn, MDBIcon } from "mdb-vue-ui-kit";
              import { MDBTableEditor } from "mdb-vue-table-editor";
              import { ref } from "vue";

              export default {
                components: {
                  MDBInput, MDBBtn, MDBIcon, MDBTableEditor
                },
                setup() {
                  const confirmEditorRef = ref(null);
                  const confirmSearch = ref("");
                  const confirmEdit = ref(false);
                  const confirmData = ref({
                    columns: [
                      {
                        width: 250,
                        label: "Company",
                        field: "company"
                      },
                      {
                        width: 250,
                        sort: false,
                        defaultValue: "Warsaw",
                        options: ["London", "Warsaw", "New York"],
                        inputType: "select",
                        label: "Office",
                        field: "office"
                      },
                      {
                        width: 250,
                        inputType: "number",
                        defaultValue: 1,
                        label: "Employees",
                        field: "employees"
                      },
                      {
                        width: 100,
                        defaultValue: false,
                        inputType: "checkbox",
                        label: "International",
                        field: "international"
                      },
                    ],
                    rows: [
                      {
                        company: "Smith & Johnson",
                        office: "London",
                        employees: 30,
                        international: true,
                      },
                      {
                        company: "P.J. Company",
                        office: "London",
                        employees: 80,
                        international: false,
                      },
                      {
                        company: "Food & Wine",
                        office: "London",
                        employees: 12,
                        international: false,
                      },
                      {
                        company: "IT Service",
                        office: "London",
                        employees: 17,
                        international: false,
                      },
                      {
                        company: "A. Jonson Gallery",
                        office: "London",
                        employees: 4,
                        international: false,
                      },
                      {
                        company: "F.A. Architects",
                        office: "London",
                        employees: 4,
                        international: false,
                      }
                    ]
                  });
                  
                  return {
                    confirmEditorRef,
                    confirmSearch,
                    confirmEdit,
                    confirmData,
                  }
                }
              };
            </script>
          
        
    
        
            
            <script setup lang="ts">
              import { MDBInput, MDBBtn, MDBIcon } from "mdb-vue-ui-kit";
              import { MDBTableEditor } from "mdb-vue-table-editor";
              import { ref } from "vue";

              const confirmEditorRef = ref<InstanceType<typeof MDBTableEditor> | null>(null);
              const confirmSearch = ref("");
              const confirmEdit = ref(false);
              const confirmData = ref({
                columns: [
                  {
                    width: 250,
                    label: "Company",
                    field: "company"
                  },
                  {
                    width: 250,
                    sort: false,
                    defaultValue: "Warsaw",
                    options: ["London", "Warsaw", "New York"],
                    inputType: "select",
                    label: "Office",
                    field: "office"
                  },
                  {
                    width: 250,
                    inputType: "number",
                    defaultValue: 1,
                    label: "Employees",
                    field: "employees"
                  },
                  {
                    width: 100,
                    defaultValue: false,
                    inputType: "checkbox",
                    label: "International",
                    field: "international"
                  },
                ],
                rows: [
                  {
                    company: "Smith & Johnson",
                    office: "London",
                    employees: 30,
                    international: true,
                  },
                  {
                    company: "P.J. Company",
                    office: "London",
                    employees: 80,
                    international: false,
                  },
                  {
                    company: "Food & Wine",
                    office: "London",
                    employees: 12,
                    international: false,
                  },
                  {
                    company: "IT Service",
                    office: "London",
                    employees: 17,
                    international: false,
                  },
                  {
                    company: "A. Jonson Gallery",
                    office: "London",
                    employees: 4,
                    international: false,
                  },
                  {
                    company: "F.A. Architects",
                    office: "London",
                    employees: 4,
                    international: false,
                  }
                ]
              });
            </script>
          
        
    


Async data

While awaiting data from API, you can prevent a user from interacting with Table Editor by setting loading option to true.


        
            
            <template>
              <div class="d-flex justify-content-between mb-4">
                <MDBBtn color="primary" size="sm" @click="loadAsyncData">Load data</MDBBtn>
                <div class="d-flex justify-content-end">
                  <MDBInput v-model="asyncSearch" label="Search" :disabled="asyncEdit" />
                  <MDBBtn 
                    color="primary" 
                    size="sm" 
                    class="ms-3" 
                    @click="asyncEditorRef?.addRow()" 
                    :disabled="asyncEdit"
                  >
                    <MDBIcon icon="plus"/>
                  </MDBBtn>
                </div>
              </div>
              <hr />
              <MDBTableEditor 
                v-model:dataset="asyncData" 
                :search="asyncSearch" 
                :loading="loadingAsync" 
                v-model:edit="asyncEdit"
                ref="asyncEditorRef" 
              />
            </template>
          
        
    
        
            
            <script>
              import { MDBInput, MDBBtn, MDBIcon } from "mdb-vue-ui-kit";
              import { MDBTableEditor } from "mdb-vue-table-editor";
              import { ref } from "vue";

              export default {
                components: {
                  MDBInput, MDBBtn, MDBIcon, MDBTableEditor
                },
                setup() {
                  const asyncEditorRef = ref(null);
                  const asyncSearch = ref("");
                  const asyncEdit = ref(false);
                  const asyncData = ref({
                    columns: [
                      { label: "Company", field: "company" },
                      { label: "Email", field: "email" },
                      { label: "Name", field: "name" },
                      { label: "Phone", field: "phone" },
                    ],
                    rows: [],
                  });
                  const loadingAsync = ref(false);
                  const loadAsyncData = () => {
                    asyncData.value.rows = [];
                    loadingAsync.value = true;
                    fetch("https://jsonplaceholder.typicode.com/users")
                      .then((response) => response.json())
                      .then((data) => {
                        asyncData.value.rows = data.map((user) => ({
                          ...user,
                          address: `${user.address.city}, ${user.address.street}`,
                          company: user.company.name,
                        }));
                        loadingAsync.value = false;
                      });
                  }
                  
                  return {
                    asyncEditorRef,
                    asyncSearch,
                    asyncEdit,
                    asyncData,
                    loadingAsync,
                    loadAsyncData,
                  }
                }
              };
            </script>
          
        
    
        
            
            <script setup lang="ts">
              import { MDBInput, MDBBtn, MDBIcon } from "mdb-vue-ui-kit";
              import { MDBTableEditor } from "mdb-vue-table-editor";
              import { ref } from "vue";

              const asyncEditorRef = ref<InstanceType<typeof MDBTableEditor> | null>(null);
              const asyncSearch = ref("");
              const asyncEdit = ref(false);
              const asyncData = ref({
                columns: [
                  { label: "Company", field: "company" },
                  { label: "Email", field: "email" },
                  { label: "Name", field: "name" },
                  { label: "Phone", field: "phone" },
                ],
                rows: [],
              });
              const loadingAsync = ref(false);
              const loadAsyncData = () => {
                asyncData.value.rows = [];
                loadingAsync.value = true;
                fetch("https://jsonplaceholder.typicode.com/users")
                  .then((response) => response.json())
                  .then((data) => {
                    asyncData.value.rows = data.map((user) => ({
                      ...user,
                      address: `${user.address.city}, ${user.address.street}`,
                      company: user.company.name,
                    }));
                    loadingAsync.value = false;
                  });
              };
            </script>
          
        
    

Custom rows

The add() method takes an optional argument - a row which values will be preloaded into a new entry.

Note: for this particular use, a row has to be an object.

Note: as adding buttons are initialized manually, they won't be automatically disabled in the edit mode.

M.B.

(5 Avenue 26, New York)

Berkley & Clark

(43th Street 12, New York)

D&D Inc.

(14 Street 67, New York)

Thomas & Co.

(2 Avenue 54, New York)


        
            
            <template>
            <MDBRow>
              <MDBCol md="3" sm="6" class="p-3">
                <h4>M.B.</h4>
                <p>(5 Avenue 26, New York)</p>
                <MDBBtn 
                  color="primary" 
                  size="sm" 
                  @click="
                    customRowsEditorRef?.addRow({
                      company: 'M.B.',
                      address: '5 Avenue 26',
                      city: 'New York'
                    })
                  "
                >
                  Load into table
                </MDBBtn>
              </MDBCol>
              <MDBCol md="3" sm="6" class="p-3">
                <h4>Berkley & Clark</h4>
                <p>(43th Street 12, New York)</p>
                <MDBBtn 
                  color="primary" 
                  size="sm" 
                  @click="
                    customRowsEditorRef?.addRow({
                      company: 'Berkley & Clark',
                      address: '43th Street 12',
                      city: 'New York'
                    })
                  "
                >
                  Load into table
                </MDBBtn>
              </MDBCol>
              <MDBCol md="3" sm="6" class="p-3">
                <h4>D&D Inc.</h4>
                <p>(14 Street 67, New York)</p>
                <MDBBtn 
                  color="primary" 
                  size="sm" 
                  @click="
                    customRowsEditorRef?.addRow({
                      company: 'D&D Inc.',
                      address: '14 Street 67',
                      city: 'New York'
                    })
                  "
                >
                  Load into table
                </MDBBtn>
              </MDBCol>
              <MDBCol md="3" sm="6" class="p-3">
                <h4>Thomas & Co.</h4>
                <p>(2 Avenue 54, New York)</p>
                <MDBBtn 
                  color="primary" 
                  size="sm" 
                  @click="
                    customRowsEditorRef?.addRow({
                      company: 'Thomas & Co.',
                      address: '2 Avenue 54',
                      city: 'New York'
                    })
                  "
                >
                  Load into table
                </MDBBtn>
              </MDBCol>
            </MDBRow>
            <hr class="mt-3" />
            <MDBTableEditor 
              v-model:dataset="customRowsData" 
              :search="customRowsSearch" 
              v-model:edit="customRowsEdit"
              ref="customRowsEditorRef" 
            />
            </template>
          
        
    
        
            
            <script>
              import { MDBBtn, MDBCol, MDBRow } from "mdb-vue-ui-kit";
              import { MDBTableEditor } from "mdb-vue-table-editor";
              import { ref } from "vue";
              
              export default {
                components: {
                  MDBBtn, MDBCol, MDBRow, MDBTableEditor
                },
                setup() {
                  const customRowsEditorRef = ref(null);
                  const customRowsSearch = ref("");
                  const customRowsEdit = ref(false);
                  const customRowsData = ref({
                    columns: [
                      {
                        width: 250,
                        label: "Company",
                        field: "company",
                      },
                      {
                        width: 250,
                        label: "Address",
                        field: "address",
                      },
                      {
                        width: 250,
                        label: "City",
                        field: "city",
                      },
                    ],
                    rows: [
                      { company: "Smith & Johnson", address: "Park Lane 2", city: "London" },
                      { company: "P.J. Company", address: "Oak Street 7", city: "Aberdeen" },
                      {
                        company: "Food & Wine",
                        address: "Netherhall Gardens 3",
                        city: "Hampstead",
                      },
                      { company: "IT Service", address: "Warwick Road 14", city: "London" },
                      {
                        company: "A. Jonson Gallery",
                        address: "Oaklands Avenue 2",
                        city: "London",
                      },
                      {
                        company: "F.A. Architects",
                        address: "Frognal Way 7",
                        city: "Hampstead",
                      },
                    ],
                  });
                  return {
                    customRowsEditorRef,
                    customRowsSearch,
                    customRowsEdit,
                    customRowsData,
                  }
                }
              };
            </script>
          
        
    
        
            
            <script setup lang="ts">
              import { MDBBtn, MDBCol, MDBRow } from "mdb-vue-ui-kit";
              import { MDBTableEditor } from "mdb-vue-table-editor";
              import { ref } from "vue";

              const customRowsEditorRef = ref<InstanceType<typeof MDBTableEditor> | null>(null);
              const customRowsSearch = ref("");
              const customRowsEdit = ref(false);
              const customRowsData = ref({
                columns: [
                  {
                    width: 250,
                    label: "Company",
                    field: "company",
                  },
                  {
                    width: 250,
                    label: "Address",
                    field: "address",
                  },
                  {
                    width: 250,
                    label: "City",
                    field: "city",
                  },
                ],
                rows: [
                  { company: "Smith & Johnson", address: "Park Lane 2", city: "London" },
                  { company: "P.J. Company", address: "Oak Street 7", city: "Aberdeen" },
                  {
                    company: "Food & Wine",
                    address: "Netherhall Gardens 3",
                    city: "Hampstead",
                  },
                  { company: "IT Service", address: "Warwick Road 14", city: "London" },
                  {
                    company: "A. Jonson Gallery",
                    address: "Oaklands Avenue 2",
                    city: "London",
                  },
                  {
                    company: "F.A. Architects",
                    address: "Frognal Way 7",
                    city: "Hampstead",
                  },
                ],
              });
            </script>
          
        
    

Notifications

In this example, handlers for custom events trigger notifications after adding/deleting/updating an entry.

        
            
            <template>
              <div class="d-flex justify-content-end mb-4">
                <MDBInput v-model="notificationsSearch" label="Search" :disabled="notificationsEdit" />
                <MDBBtn 
                  color="primary" 
                  size="sm" 
                  class="ms-3" 
                  @click="notificationsEditorRef?.addRow()"
                  :disabled="notificationsEdit"
                >
                  <MDBIcon icon="plus"/>
                </MDBBtn>
              </div>
              <hr />
              <MDBTableEditor 
                v-model:dataset="notificationsData" 
                :search="notificationsSearch" 
                v-model:edit="notificationsEdit"
                ref="notificationsEditorRef" 
                @add="showNotification('success', 'New entry: ', $event)"
                @delete="showNotification('danger', 'Deleted entry: ', $event)" 
                @updateEntry="showNotification('primary', 'Updated entry: ', $event)"
              />
              <MDBAlert 
                v-model="alert" 
                :color="alertColor" 
                position="top-right" 
                width="360px" 
                :delay="2000" 
                autohide
              >
                <div v-html="alertMessage" />
              </MDBAlert>
            </template>
          
        
    
        
            
            <script>
              import { MDBInput, MDBBtn, MDBIcon, MDBAlert } from "mdb-vue-ui-kit";
              import { MDBTableEditor } from "mdb-vue-table-editor";
              import { ref } from "vue";
              
              export default {
                components: {
                  MDBInput, MDBBtn, MDBIcon, MDBAlert, MDBTableEditor
                },
                setup() {
                  const notificationsEditorRef = ref(null);
                  const notificationsSearch = ref("");
                  const notificationsEdit = ref(false);
                  const notificationsData = ref({
                    columns: [
                      {
                        width: 250,
                        label: "Company",
                        field: "company",
                      },
                      {
                        width: 250,
                        sort: false,
                        defaultValue: "Warsaw",
                        options: ["London", "Warsaw", "New York"],
                        inputType: "select",
                        label: "Office",
                        field: "office",
                      },
                      {
                        width: 250,
                        inputType: "number",
                        defaultValue: 1,
                        label: "Employees",
                        field: "employees",
                      },
                      {
                        width: 100,
                        defaultValue: false,
                        inputType: "checkbox",
                        label: "International",
                        field: "international",
                      },
                    ],
                    rows: [
                      {
                        company: "Smith & Johnson",
                        office: "London",
                        employees: 30,
                        international: true,
                      },
                      {
                        company: "P.J. Company",
                        office: "London",
                        employees: 80,
                        international: false,
                      },
                      {
                        company: "Food & Wine",
                        office: "London",
                        employees: 12,
                        international: false,
                      },
                      {
                        company: "IT Service",
                        office: "London",
                        employees: 17,
                        international: false,
                      },
                      {
                        company: "A. Jonson Gallery",
                        office: "London",
                        employees: 4,
                        international: false,
                      },
                      {
                        company: "F.A. Architects",
                        office: "London",
                        employees: 4,
                        international: false,
                      },
                    ]
                  });
                  const alert = ref(false);
                  const alertColor = ref("primary");
                  const alertMessage = ref("");
                  const showNotification = (type, message, event) => {
                    const { company, office } = event.row;
                    alertMessage.value = `<strong>${message}</strong> ${company} ${office}`;
                    alertColor.value = type;
                    alert.value = true;
                  };
                  return {
                    showNotification,
                    notificationsEditorRef,
                    notificationsSearch,
                    notificationsEdit,
                    notificationsData,
                    alert,
                    alertColor,
                    alertMessage,
                  }
                }
              };
            </script>
          
        
    
        
            
            <script setup lang="ts">
              import { MDBInput, MDBBtn, MDBIcon, MDBAlert } from "mdb-vue-ui-kit";
              import { MDBTableEditor } from "mdb-vue-table-editor";
              import { ref } from "vue";

              const notificationsEditorRef = ref<InstanceType<typeof MDBTableEditor> | null>(null);
              const notificationsSearch = ref("");
              const notificationsEdit = ref(false);
              const notificationsData = ref({
                columns: [
                  {
                    width: 250,
                    label: "Company",
                    field: "company",
                  },
                  {
                    width: 250,
                    sort: false,
                    defaultValue: "Warsaw",
                    options: ["London", "Warsaw", "New York"],
                    inputType: "select",
                    label: "Office",
                    field: "office",
                  },
                  {
                    width: 250,
                    inputType: "number",
                    defaultValue: 1,
                    label: "Employees",
                    field: "employees",
                  },
                  {
                    width: 100,
                    defaultValue: false,
                    inputType: "checkbox",
                    label: "International",
                    field: "international",
                  },
                ],
                rows: [
                  {
                    company: "Smith & Johnson",
                    office: "London",
                    employees: 30,
                    international: true,
                  },
                  {
                    company: "P.J. Company",
                    office: "London",
                    employees: 80,
                    international: false,
                  },
                  {
                    company: "Food & Wine",
                    office: "London",
                    employees: 12,
                    international: false,
                  },
                  {
                    company: "IT Service",
                    office: "London",
                    employees: 17,
                    international: false,
                  },
                  {
                    company: "A. Jonson Gallery",
                    office: "London",
                    employees: 4,
                    international: false,
                  },
                  {
                    company: "F.A. Architects",
                    office: "London",
                    employees: 4,
                    international: false,
                  },
                ]
              });
              const alert = ref(false);
              const alertColor = ref("primary");
              const alertMessage = ref("");
              const showNotification = (type: string, message: string, event: Event) => {
                const { company, office } = event.row;
                alertMessage.value = `<strong>${message}</strong> ${company} ${office}`;
                alertColor.value = type;
                alert.value = true;
              };
            </script>
          
        
    

GET

UP TO 98% OFF

Check out our bundles and get up to 98% off PRO components.

Table editor - API


Import

        
            
          <script>
            import { MDBTableEditor } from "mdb-vue-table-editor";
          </script>
        
        
    

Properties

Property Type Default Description
actionHeader String 'Actions' Header for action buttons
actionPosition String 'end' Decides where to render an action column (start/end)
allowEmptyCells Boolean false Allows to add empty cells in addRow method
bordered Boolean false Adds borders to a datatable
borderless Boolean false Removes all borders from a datatable
borderColor String Changes a border color to one of main colors
cancelText String 'Cancel' Text displayed in cancel buttons
confirm Boolean false Displays a Popconfirm element before removing an entry
confirmText String 'Cancel' Text displayed in confirm buttons (Popconfirm)
confirmMessage String 'Are you sure you want to delete this entry?' Text displayed in a Popconfirm element
color String Adds a color class to a datatable (f.e 'bg-dark')
defaultValue String "-" This string will be used as a placeholder if a row doesn't have a defined value for a column
dataset Object { columns: [], rows: [] } Main data object
v-model:edit Boolean false Keeps information about edit mode
entries Number 10 Number of visible entries (pagination)
entriesOptions Array [10, 25, 50, 200] Options available to choose from in a pagination select (rows per page)
fixedHeader Boolean false When it's set to true, the table's header will remain visible while scrolling
fullPagination Boolean false Displays additional buttons for the first and last pages
hover Boolean false Changes the background color of a hovered row
loaderClass String "bg-primary" The class name for a loader (loading mode)
loading Boolean false Sets the loading mode - disables interactions and displays a loader
loadingMessage String "Loading results..." A message displayed while loading data
maxHeight [Number, String] Sets a maximum height of a datatable - can be either a string ("10%") or a number of pixels.
maxWidth [Number, String] "100%" Sets a maximum width of a datatable - can be either a string ("10%") or a number of pixels.
mode String 'inline' Changes edit mode - available options: 'inline', 'modal'
multi Boolean false Allows selecting multiple rows (selectable mode)
newItemHeader String 'New item' A header of modal
noFoundMessage String "No matching results found" A message displayed when a table is empty
pagination Boolean true Shows/hides the pagination panel
rowsText String "Rows per page:" A text indicating a number of rows per page
saveText String 'Save Text displayed in the save button (modal)
search String Search phrase
searchColumns Array [] Columns to include while searching. All columns included for an empty array
selectable Boolean false Enables selecting rows with checkboxes
sm Boolean false Decreases a row's paddings
sortField String Default sorted column enabled by a field name
sortOrder String Default sorting order. Available values: "asc" or "desc".
striped Boolean false Slightly changes the background's color in every other row
tag String "div" Defines wrapper tag

Column properties

Name Type Default Description
editable Boolean true Enables/disabled editing fields in this column
label String '' A displayed header of a column
field String label.toLowerCase() A field's name - will be used as a key for values in rows
fixed [Boolean, String] false When set to true, makes a column stick on the left while scrolling. Changing its value to right will do the same on the other side. For this option to work, you need to define width as well.
inputType String 'text' Input type for a column. Available options: 'text', 'number', 'checkbox', 'select'
options Array [] Array of options (for column with a "select" input type)
width Number A column's width in pixels
sort Boolean true Enables/disables sorting for this column
format Array Cell formatting array of objects for each cell.

Methods

Name Description
addRow Adds a new row (default values are optional).
        
            
        <template>
          <div class="d-flex justify-content-end mb-4">
            <MDBInput
              v-model="basicSearch"
              label="Search"
              :disabled="basicEdit"
            />
            <MDBBtn
              color="primary"
              size="sm"
              class="ms-3"
              @click="basicEditorRef?.addRow()"
              :disabled="basicEdit"
            >
              <MDBIcon icon="plus"/>
            </MDBBtn>
          </div>
          <hr />
          <MDBTableEditor
            :search="basicSearch"
            :entries="5"
            :entriesOptions="[5, 10, 15]"
            v-model:edit="basicEdit"
            ref="basicEditorRef"
          >
            <table class="table">
              <thead>
                <tr>
                  <th class="th-sm" data-mdb-width="250">Company</th>
                  <th class="th-sm" data-mdb-width="250" data-mdb-sort="false">
                    Address
                  </th>
                  <th class="th-sm" data-mdb-width="250" data-mdb-sort="false">
                    Employees
                  </th>
                </tr>
              </thead>
              <tbody>
                <tr>
                  <td>Smith & Johnson</td>
                  <td>Park Lane 2, London</td>
                  <td>30</td>
                </tr>
                <tr>
                  <td>P.J. Company</td>
                  <td>Oak Street 7, Aberdeen</td>
                  <td>80</td>
                </tr>
                <tr>
                  <td>Food & Wine</td>
                  <td>Netherhall Gardens 3, Hampstead</td>
                  <td>12</td>
                </tr>
                <tr>
                  <td>IT Service</td>
                  <td>Warwick Road 14, London</td>
                  <td>17</td>
                </tr>
                <tr>
                  <td>A. Jonson Gallery</td>
                  <td>Oaklands Avenue 2, London</td>
                  <td>4</td>
                </tr>
                <tr>
                  <td>F.A. Architects</td>
                  <td>Frognal Way 7, Hampstead</td>
                  <td>4</td>
                </tr>
              </tbody>
            </table>
          </MDBTableEditor>
        </template>
        
        
    
        
            
        <script>
          import { MDBInput, MDBBtn, MDBIcon } from "mdb-vue-ui-kit";
          import { MDBTableEditor } from "mdb-vue-table-editor";
          import { ref } from "vue";
          export default {
            components: {
              MDBInput, MDBBtn, MDBIcon, MDBTableEditor
            },
            setup() {
              const basicEditorRef = ref(null);
              const basicSearch = ref("");
              const basicEdit = ref(false);
        
              return {
                basicEditorRef,
                basicSearch,
                basicEdit,
              }
            }
          };
        </script>
        
        
    
        
            
        <script setup lang="ts">
          import { MDBInput, MDBBtn, MDBIcon } from "mdb-vue-ui-kit";
          import { MDBTableEditor } from "mdb-vue-table-editor";
          import { ref } from "vue";
        
          const basicEditorRef = ref<InstanceType<typeof MDBTableEditor> | null>(null);
          const basicSearch = ref("");
          const basicEdit = ref(false);
        </script>
        
        
    

Events

Name Description
add This event fires after adding a new row.
delete This event fires after deleting a row.
edit This event fires when user enters edit mode. Allows to get the current edited row via parameter.
exit This event fires when user exits edit mode.
render Event emitted after the component renders/updates rows.
update This event fires in an editable mode when a user updates values.
        
            
          <template>
            <MDBTableEditor @add="doSomething" >...</MDBTableEditor>
          </template>